/*********************************************************************
 *
 *                  MCP4725 Library definitions
 *         			12-Bit I2C DAC
 *
 *********************************************************************
 * FileName:        mcp4725_lib.c
 * Dependencies:
 * Processor:       PIC32
 *
 * Complier:        MPLAB C32
 *                  MPLAB IDE
 * Author:			Carl
 ********************************************************************/
#include <plib.h>
//*****************************************************
//	I2C2 Issue on PIC32 library function	IdleI2C2();
//
//	Use this instead of library because of a typo in the library call IdleI2C2();
//
//		while(I2C2CONbits.RSEN) {};  //wait for RSEN to go low 
//		IdleI2C2();		//bug in this library code, use with above line for I2C2
//
//	 IdleI2C1(); works just fine for I2C1
//
//***********************************************************************/
//
//					I2C1 port
//
//***********************************************************************
void MCP4725_I2C1_write_FastMode(unsigned char SlaveAddr, unsigned char Data_Hi_byte, unsigned char Data_Lo_byte)
{
	char i2cData[3];
	int DataSz;
	int Index;
 
	i2cData[0] = SlaveAddr;			//Slave Address, Device address and WR Command
 	i2cData[1] = Data_Hi_byte;		//Hi data byte
	i2cData[2] = Data_Lo_byte;		//Lo data byte

	DataSz = 3;
	StartI2C1();					//Send the Start Bit
//	while(I2C1CONbits.RSEN) {};  	//wait for RSEN to go low 
	IdleI2C1();						//bug in this library code, use with above line for I2C2

	Index = 0;
	while(DataSz)
	{
	MasterWriteI2C1( i2cData[Index++] );
//	while(I2C1CONbits.RSEN) {};  	//wait for RSEN to go low 
	IdleI2C1();						//bug in this library code, use with above line for I2C2
	
	DataSz--;
	}

	StopI2C1();						//Send the Stop condition
//	while(I2C1CONbits.RSEN) {};  	//wait for RSEN to go low 
	IdleI2C1();						//bug in this library code, use with above line for I2C2
	return;
}

void MCP4725_I2C1_write_DAC_EEPROM(unsigned char SlaveAddr, unsigned char Cmd_byte, unsigned char Data_Hi_byte, unsigned char Data_Lo_byte)
{
	char i2cData[4];
	int DataSz;
	int Index;
 
	i2cData[0] = SlaveAddr;			//Slave Address, Device address and WR Command
 	i2cData[1] = Cmd_byte;			//Command byte
 	i2cData[2] = Data_Hi_byte;		//Hi data byte
	i2cData[3] = Data_Lo_byte;		//Lo data byte

	DataSz = 4;
	StartI2C1();					//Send the Start Bit
//	while(I2C1CONbits.RSEN) {};  	//wait for RSEN to go low 
	IdleI2C1();						//bug in this library code, use with above line for I2C2

	Index = 0;
	while(DataSz)
	{
	MasterWriteI2C1( i2cData[Index++] );
//	while(I2C1CONbits.RSEN) {};  	//wait for RSEN to go low 
	IdleI2C1();						//bug in this library code, use with above line for I2C2

	DataSz--;
	}

	StopI2C1();						//Send the Stop condition
//	while(I2C1CONbits.RSEN) {};  	//wait for RSEN to go low 
	IdleI2C1();						//bug in this library code, use with above line for I2C2
	return;
}



//***********************************************************************/
//
//					I2C2 port
//
//***********************************************************************
void MCP4725_I2C2_write_FastMode(unsigned char SlaveAddr, unsigned char Data_Hi_byte, unsigned char Data_Lo_byte)
{
	char i2cData[3];
	int DataSz;
	int Index;
 
	i2cData[0] = SlaveAddr;			//Slave Address, Device address and WR Command
 	i2cData[1] = Data_Hi_byte;		//Hi data byte
	i2cData[2] = Data_Lo_byte;		//Lo data byte

	DataSz = 3;
	StartI2C2();					//Send the Start Bit
	while(I2C2CONbits.RSEN) {};  	//wait for RSEN to go low 
	IdleI2C2();						//bug in this library code, use with above line for I2C2

	Index = 0;
	while(DataSz)
	{
	MasterWriteI2C2( i2cData[Index++] );
	while(I2C2CONbits.RSEN) {};  	//wait for RSEN to go low 
	IdleI2C2();						//bug in this library code, use with above line for I2C2
	
	DataSz--;
	}

	StopI2C2();						//Send the Stop condition
	while(I2C2CONbits.RSEN) {};  	//wait for RSEN to go low 
	IdleI2C2();						//bug in this library code, use with above line for I2C2
	return;
}

void MCP4725_I2C2_write_DAC_EEPROM(unsigned char SlaveAddr, unsigned char Cmd_byte, unsigned char Data_Hi_byte, unsigned char Data_Lo_byte)
{
	char i2cData[4];
	int DataSz;
	int Index;
 
	i2cData[0] = SlaveAddr;			//Slave Address, Device address and WR Command
 	i2cData[1] = Cmd_byte;			//Command byte
 	i2cData[2] = Data_Hi_byte;		//Hi data byte
	i2cData[3] = Data_Lo_byte;		//Lo data byte

	DataSz = 4;
	StartI2C2();					//Send the Start Bit
	while(I2C2CONbits.RSEN) {};  	//wait for RSEN to go low 
	IdleI2C2();						//bug in this library code, use with above line for I2C2

	Index = 0;
	while(DataSz)
	{
	MasterWriteI2C2( i2cData[Index++] );
	while(I2C2CONbits.RSEN) {};  	//wait for RSEN to go low 
	IdleI2C2();						//bug in this library code, use with above line for I2C2

	DataSz--;
	}

	StopI2C2();						//Send the Stop condition
	while(I2C2CONbits.RSEN) {};  	//wait for RSEN to go low 
	IdleI2C2();						//bug in this library code, use with above line for I2C2
	return;
}

