/******************************************************************************
 * FileName:        BMS_ADC_scan_setup.c

 *********************************************************************
 * File Description: BMS ADC SCAN Function for 11 analog channels
 * Break this up into a state machine in the main BMS loop
 ********************************************************************/
 
// Configuration Bit settings
// SYSCLK = 80 MHz (8MHz Crystal/ FPLLIDIV * FPLLMUL / FPLLODIV)
// PBCLK = 40 MHz
// Primary Osc w/PLL (XT+,HS+,EC+PLL)
// WDT OFF
// Other options are don't care
//
// #pragma config FPLLMUL = MUL_20, FPLLIDIV = DIV_2, FPLLODIV = DIV_1, FWDTEN = OFF
// #pragma config POSCMOD = HS, FNOSC = PRIPLL, FPBDIV = DIV_2

/////////////////////////////////////////////
// ADC1BUF array is used as follows:
// ADC1BUF[0] = AN3 Daylight LDR sensor
// ADC1BUF[1] = AN4 Hive humidity sensor
// ADC1BUF[2] = AN5 Audio in
// ADC1BUF[3] = AN8 12vmon
// ADC1BUF[4] = AN9 5vmon
// ADC1BUF[5] = AN10 3vmonP32
// ADC1BUF[6] = AN11 3vmonIO
// ADC1BUF[7] = AN12 3vmonFRAME
// ADC1BUF[8] = AN13
// ADC1BUF[9] = AN14
// ADC1BUF[10] = AN15
/////////////////////////////////////////////

	// configure and enable the ADC
	CloseADC10();// ensure the ADC is off before setting the configuration
	// configure ADC 

	AD1CON1 = 0x00E4;
	AD1CON2 = 0x0428;
	AD1CON3 = 0x8C00;
	AD1CSSL = 0xFF38;
	AD1CON1bits.ADON = 1;	//start the ADC scan
//	AD1CON1bits.SAMP = 1;
//	AD1CON1 = 0x80E6;	
