//===============================================================
//	BMS_AlarmState.c
//	State machine to test for alarms and send emails as configured
//	this file is an include file in "BMS_ProcessIO.c"
//===============================================================

// first set indicator LEDS if needed for security issues, no states used here because they are fast checks
if (SW_LidOpen_IO)						//test for lid open, if so turn indicator LED on
	Tamper_Alarm_LEDio = 1;
		else
			Tamper_Alarm_LEDio = 0;

if (SW_TiltDetect_IO)					//test for tilt, if so turn indicator LED on
	Hive_Movement_Alarm_LEDio = 1;
		else
			Hive_Movement_Alarm_LEDio = 0;

if ((SW_PIR_1_IO) || (SW_PIR_2_IO) || (SW_PIR_3_IO) || (SW_PIR_4_IO))	//test for PIR movement, if so turn indicator LED on
	PIR_Motion_Alarm_LEDio = 1;
		else
			PIR_Motion_Alarm_LEDio = 0;
//END of LEDS for security issues

// now check security issues for alarm emails if needed, using state machine control to limit time in this routine
if ((EmailAlertBusyFlag == FALSE) && (FunctionModule[EmailAlertEnableFlag].Status.Enabled == TRUE))		//check to make sure email is not currently busy doing something
{
	switch(ALARMCHECKState)
	{
	case ALARM_HOME:
	break;

	case LID_OPEN_SENSOR:	//check lid open sensor
	if ((FunctionModule[Elidopen].Status.Installed == FALSE)||		//first see if we should just skip this check
		 (FunctionModule[Elidopen].Status.Enabled== FALSE) ||
		 (FunctionModule[Elidopen].Status.AlarmEnable == FALSE))
	break;															//yea, skip this check
		if ((FunctionModule[Elidopen].Status.Installed == TRUE)&&		//ok, make sure all conditions are go for alarm check
		 (FunctionModule[Elidopen].Status.Enabled== TRUE) &&
		 (FunctionModule[Elidopen].Status.AlarmEnable == TRUE))
		{															//all systems go for alarm check
			if ((SW_LidOpen_IO) && !(Repeat_Alarm_HoldOff.LidOpenFlag))	//Lid Open = 1 & check the repeat alarm wait period, send email alarm
			{
			//Use the repeat alarm wait time which was configured in FunctionModule[Elidopen].DataValue1
			AlarmWaitTime[Elidopen] = (FunctionModule[Elidopen].DataValue1 * 2); //need to x2 because ticks are 1/2 sec
			Repeat_Alarm_HoldOff.LidOpenFlag = TRUE;
			SubjectID = Elidopen;					//email subject ID
			SMTP_BMSalert();			//send message for Elidopen
			}
		}//END of Alarm check was go to test
	break;

	case TILT_SENSOR:		//check tilt sensor
	if ((FunctionModule[Etiltdetect].Status.Installed == FALSE)||		//first see if we should just skip this check
		 (FunctionModule[Etiltdetect].Status.Enabled== FALSE) ||
		 (FunctionModule[Etiltdetect].Status.AlarmEnable == FALSE))
	break;
		if ((FunctionModule[Etiltdetect].Status.Installed == TRUE)&&		//ok, make sure all conditions are go for alarm check
		 (FunctionModule[Etiltdetect].Status.Enabled== TRUE) &&
		 (FunctionModule[Etiltdetect].Status.AlarmEnable == TRUE))
		{															//all systems go for alarm check
			if ((SW_TiltDetect_IO) && !(Repeat_Alarm_HoldOff.TiltFlag))	//Tilt = 1 & check the repeat alarm wait period, send email alarm
			{
			//Use the repeat alarm wait time which was configured in FunctionModule[Elidopen].DataValue1
			AlarmWaitTime[Etiltdetect] = (FunctionModule[Etiltdetect].DataValue1 * 2); //need to x2 because ticks are 1/2 sec
			Repeat_Alarm_HoldOff.TiltFlag = TRUE;
			SubjectID = Etiltdetect;			//email subject ID
			SMTP_BMSalert();			//send message for Etiltdetect
			}
		}//END of Alarm check was go to test
	break;

	case PIR1_SENSOR:		//PIR 1 sensor
	if ((FunctionModule[EPIR1ms].Status.Installed == FALSE)||		//first see if we should just skip this check
		 (FunctionModule[EPIR1ms].Status.Enabled== FALSE) ||
		 (FunctionModule[EPIR1ms].Status.AlarmEnable == FALSE))
	break;
		if ((FunctionModule[EPIR1ms].Status.Installed == TRUE)&&		//ok, make sure all conditions are go for alarm check
		 (FunctionModule[EPIR1ms].Status.Enabled== TRUE) &&
		 (FunctionModule[EPIR1ms].Status.AlarmEnable == TRUE))
		{															//all systems go for alarm check
			if ((SW_PIR_1_IO) && !(Repeat_Alarm_HoldOff.PIR1Flag))	//PIR 1 = 1 & check the repeat alarm wait period, send email alarm
			{
			//Use the repeat alarm wait time which was configured in FunctionModule[Elidopen].DataValue1
			AlarmWaitTime[EPIR1ms] = (FunctionModule[EPIR1ms].DataValue1 * 2); //need to x2 because ticks are 1/2 sec
			Repeat_Alarm_HoldOff.PIR1Flag = TRUE;
			SubjectID = EPIR1ms;			//email subject ID
			SMTP_BMSalert();			//send message for EPIR1ms
			}
		}//END of Alarm check was go to test
	break;

	case PIR2_SENSOR:		//PIR 2 sensor
	if ((FunctionModule[EPIR2ms].Status.Installed == FALSE)||		//first see if we should just skip this check
		 (FunctionModule[EPIR2ms].Status.Enabled== FALSE) ||
		 (FunctionModule[EPIR2ms].Status.AlarmEnable == FALSE))
	break;
		if ((FunctionModule[EPIR2ms].Status.Installed == TRUE)&&		//ok, make sure all conditions are go for alarm check
		 (FunctionModule[EPIR2ms].Status.Enabled== TRUE) &&
		 (FunctionModule[EPIR2ms].Status.AlarmEnable == TRUE))
		{															//all systems go for alarm check
			if ((SW_PIR_2_IO) && !(Repeat_Alarm_HoldOff.PIR2Flag))	//PIR 2 = 1 & check the repeat alarm wait period, send email alarm
			{
			//Use the repeat alarm wait time which was configured in FunctionModule[Elidopen].DataValue1
			AlarmWaitTime[EPIR2ms] = (FunctionModule[EPIR2ms].DataValue1 * 2); //need to x2 because ticks are 1/2 sec
			Repeat_Alarm_HoldOff.PIR2Flag = TRUE;
			SubjectID = EPIR2ms;			//email subject ID
			SMTP_BMSalert();			//send message for EPIR2ms
			}
		}//END of Alarm check was go to test
	break;

	case PIR3_SENSOR:		//PIR 3 sensor
	if ((FunctionModule[EPIR3ms].Status.Installed == FALSE)||		//first see if we should just skip this check
		 (FunctionModule[EPIR3ms].Status.Enabled== FALSE) ||
		 (FunctionModule[EPIR3ms].Status.AlarmEnable == FALSE))
	break;
		if ((FunctionModule[EPIR3ms].Status.Installed == TRUE)&&		//ok, make sure all conditions are go for alarm check
		 (FunctionModule[EPIR3ms].Status.Enabled== TRUE) &&
		 (FunctionModule[EPIR3ms].Status.AlarmEnable == TRUE))
		{															//all systems go for alarm check
			if ((SW_PIR_3_IO) && !(Repeat_Alarm_HoldOff.PIR3Flag))	//PIR 3 = 1 & check the repeat alarm wait period, send email alarm
			{
			//Use the repeat alarm wait time which was configured in FunctionModule[Elidopen].DataValue1
			AlarmWaitTime[EPIR3ms] = (FunctionModule[EPIR3ms].DataValue1 * 2); //need to x2 because ticks are 1/2 sec
			Repeat_Alarm_HoldOff.PIR3Flag = TRUE;
			SubjectID = EPIR3ms;			//email subject ID
			SMTP_BMSalert();			//send message for EPIR3ms
			}
		}//END of Alarm check was go to test
	break;

	case PIR4_SENSOR:		//PIR 4 sensor
	if ((FunctionModule[EPIR4ms].Status.Installed == FALSE)||		//first see if we should just skip this check
		 (FunctionModule[EPIR4ms].Status.Enabled== FALSE) ||
		 (FunctionModule[EPIR4ms].Status.AlarmEnable == FALSE))
	break;
		if ((FunctionModule[EPIR4ms].Status.Installed == TRUE)&&		//ok, make sure all conditions are go for alarm check
		 (FunctionModule[EPIR4ms].Status.Enabled== TRUE) &&
		 (FunctionModule[EPIR4ms].Status.AlarmEnable == TRUE))
		{															//all systems go for alarm check
			if ((SW_PIR_4_IO) && !(Repeat_Alarm_HoldOff.PIR4Flag))	//PIR 4 = 1 & check the repeat alarm wait period, send email alarm
			{
			//Use the repeat alarm wait time which was configured in FunctionModule[Elidopen].DataValue1
			AlarmWaitTime[EPIR4ms] = (FunctionModule[EPIR4ms].DataValue1 * 2); //need to x2 because ticks are 1/2 sec
			Repeat_Alarm_HoldOff.PIR4Flag = TRUE;
			SubjectID = EPIR4ms;			//email subject ID
			SMTP_BMSalert();			//send message for EPIR4ms
			}
		}//END of Alarm check was go to test
	break;

	case ALARM_AGAIN:
	ALARMCHECKState = 0;
	break;

	default:
	break;

	}//END switch(ALARMCHECKState)
ALARMCHECKState++;
}//END if (EmailAlertBusyFlag == FALSE)
	else
		if (EmailAlertBusyFlag == TRUE)
			SMTP_BMSalert();		//Continue with present SMTP states, still sending current email message

