//============================================================
//	BMS_DataLog.c
//	Checks for when to record data to arrays and EEPROM
//  this file has functions called from BMS_DataLogTiming.c
//============================================================
//extern SENSORLOG_RECORD volatile DataLogDayArray[7][24][4]; // Hourly reading every 15min (1/4hr)
//extern BOOL TestModeBMS;
//extern BYTE LogDay;
WORD ReadRH(void);


//===============================================================================================
//
//	This function called to scan and record sensor data for datalog
//
//===============================================================================================

void DataLogHive(BYTE Reading)
{
extern SENSORLOG_RECORD volatile DataLogDayArray[7][24][4]; // Hourly reading every 15min (1/4hr)
extern 	rtccTime tm, tm1;// time structure
extern	rtccDate dt, dt1;// date structure
extern BOOL TestModeBMS;
//extern BOOL QuickDataBMS;
 
BYTE LogDay;
BYTE DayHour;
WORD Wtemp;
WORD temp2, temp3;
LogDay = dt.wday;												//use the rtcc wday for LogDay
DayHour = (((tm.hour & 0xF0)>>4) * 10 + (tm.hour & 0x0F));		//unpack the hours BCD, use rtcc hour for DayHour
Nop();


if (TestModeBMS == TRUE)		//use minutes instead of hours to log data, this generates test data in minutes not days
	{
		DayHour = (((tm.min & 0xF0)>>4) * 10 + (tm.min & 0x0F));	//run for only 24 minutes from 0 minutes
			if (DayHour > 23)										//bump dt.wday up 1 day and tm.min = 0
				{
					dt.wday = dt.wday +1;
					if (dt.wday >=7) dt.wday = 0;
					tm.min = 0;
					RtccSetTimeDate(tm.l, dt.l);	//set the RTCC with the new time
				}
	}

//format of the MCP9800 temperature data is
//	TemperatureL =(Temperature>>8);	//Whole degrees are saved in the left byte
//	TemperatureR = (Temperature & 0xFF);	//Fraction degrees are in the right byte

	Wtemp =  Mcp9800_FormattedRead(SysConTempPort,SysConTempSA);
	DataLogDayArray[LogDay][DayHour][Reading].cTSysController = Wtemp;
	temp2 = DataLogDayArray[LogDay][DayHour][Reading].cTSysController;
	temp3 = DataLogDayArray[LogDay + 1][DayHour][Reading].cTSysController;

	Wtemp = Mcp9800_FormattedRead(BaseOutTempPort,BaseOutTempSA);
	DataLogDayArray[LogDay][DayHour][Reading].cTBaseOutSide = Wtemp;

	Wtemp = Mcp9800_FormattedRead(BaseInTempPort,BaseInTempSA);
	DataLogDayArray[LogDay][DayHour][Reading].cTBaseInside = Wtemp;

	Wtemp = Mcp9800_FormattedRead(TopOutTempPort,TopOutTempSA);
	DataLogDayArray[LogDay][DayHour][Reading].cTTopOutside = Wtemp;

	Wtemp = Mcp9800_FormattedRead(TopInTempPort,TopInTempSA);
	DataLogDayArray[LogDay][DayHour][Reading].cTTopInside = Wtemp;

	Wtemp = ReadRH();
	DataLogDayArray[LogDay][DayHour][Reading].cHumidity = Wtemp;				//data stored is % * 10		(395 for 39.5%)

	Wtemp = (WORD)ADC1BUF0;
	DataLogDayArray[LogDay][DayHour][Reading].cDayLight = Wtemp; 		//data stored is % * 10		(246 for 24.6%)

	DataLogDayArray[LogDay][DayHour][Reading].cBeeTrafficOut = BeeOutCounter;
	temp2 = 	DataLogDayArray[LogDay][DayHour][Reading].cBeeTrafficOut;
	temp3 = 	DataLogDayArray[LogDay + 1][DayHour][Reading].cBeeTrafficOut;

	DataLogDayArray[LogDay][DayHour][Reading].cBeeTrafficIn = BeeInCounter;

//reset selected counters each hour at Reading_1 time
	if (Reading == Reading_1)
	{
	BeeOutCounter = 0;		//you can calculate the total bee count by using the logged data over whatever period you want
	BeeInCounter = 0;
	}
}

//==========================

