//============================================================
//	BMS_DataLogTiming.c
//	Checks for when to record data to arrays and EEPROM
//  this is an include file in BMS_ProcessIO.c
//============================================================

// DataLog15Tick is used to determine when 15 minutes have elappsed and it is time
// to sample data and log it to the "DataLogOneHourArray" four times an hour
// when it is full then copy it to the EEPROM each hour

//if (TickGet() - DataLog15Tick >= TICK_SECOND*DataLogInterval)
//	{
//	 DataLog15Tick = TickGet();	
//	Tamper_Alarm_LEDio ^= 1;		//here for code test only
//	}

Nop();
RtccGetTimeDate(&tm, &dt);		//get current time

//Production code--------------set the TTestModeBMS flag in MainDemo.c FALSE to run PRODUCTION mode
if (TestModeBMS == FALSE)
{
if (LogCompleted == FALSE)		//LogCompleted gets set at end of datalogging routine
	{
		if (tm.min <= (0x02))		//2 minute widow to start data logging
			DFlag00 = TRUE; 
		if ((tm.min >= (0x15)) && (tm.min <= (0x17)))		//2 minute widow to start data logging
			DFlag15 = TRUE;				
		if ((tm.min >= (0x30)) && (tm.min <= (0x32)))		//2 minute widow to start data logging
			DFlag30 = TRUE;
		if ((tm.min >= (0x45)) && (tm.min <= (0x47)))		//2 minute widow to start data logging
			DFlag45 = TRUE;
	}

// reset flags if enough time has elapsed
if ((tm.min == 0x05) |(tm.min == 0x20) |(tm.min == 0x35) |(tm.min == 0x50)) 
	LogCompleted = FALSE;

if ((tm.hour == 0x00) && (tm.min == 0x05) && (MidNightLogFlag == TRUE))
	MidNightLogFlag = FALSE;		// clear the MidNightLogFlag because we just finished doing it
}//END Production code configuration


//Test mode code--------------set the TTestModeBMS flag in MainDemo.c FALSE to run TEST mode
// in test mode the timing is changed from minutes to seconds to log data quicker
// also in test mode the LEDS:
//	 (00)Tamper_Alarm, (15)Hive Movement, (30)PIR Motion, and (45)Smoke Module
//	 are used to indicate a data log process in action
if (TestModeBMS == TRUE)
{
if (LogCompleted == FALSE)		//LogCompleted gets set at end of datalogging routine
	{
		if (tm.sec == (0x00))
			DFlag00 = TRUE; 
		if (tm.sec == (0x15)) 
			DFlag15 = TRUE;				
		if (tm.sec == (0x30)) 
			DFlag30 = TRUE;
		if (tm.sec == (0x45)) 
			DFlag45 = TRUE;
	}

// reset flags if enough time has elapsed
if ((tm.sec == 0x05) |(tm.sec == 0x20) |(tm.sec == 0x35) |(tm.sec == 0x50)) 
	LogCompleted = FALSE;
}//END Test mode code configuration


if (DFlag00 == TRUE)
	{
//	if (TestModeBMS) Tamper_Alarm_LEDio = 1;		//here for test only
	DataLogHive(Reading_1);		//Scan the hive's sensors and data log
	LogCompleted = TRUE;
	DFlag00 = FALSE;
	}

//if ((DFlag00 == FALSE) && (LogCompleted == FALSE))
//	Tamper_Alarm_LEDio = 0;		//here for test only

if (DFlag15 == TRUE)
	{
//	if (TestModeBMS) Hive_Movement_Alarm_LEDio = 1;		//here for test only
	DataLogHive(Reading_2);		//Scan the hive's sensors and data log
	LogCompleted = TRUE;
	DFlag15 = FALSE;
	}

//if ((DFlag15 == FALSE) && (LogCompleted == FALSE))
//	Hive_Movement_Alarm_LEDio = 0;		//here for test only

if (DFlag30 == TRUE)
	{
//	if (TestModeBMS) PIR_Motion_Alarm_LEDio = 1;		//here for test only
	DataLogHive(Reading_3);		//Scan the hive's sensors and data log
	LogCompleted = TRUE;
	DFlag30 = FALSE;
	}

//if ((DFlag30 == FALSE) && (LogCompleted == FALSE))
//	PIR_Motion_Alarm_LEDio = 0;		//here for test only

if (DFlag45 == TRUE)
	{
//	if (TestModeBMS) Smoke_Module_LEDio = 1;		//here for test only
	DataLogHive(Reading_4);		//Scan the hive's sensors and data log
	LogCompleted = TRUE;
	DFlag45 = FALSE;
	}

//===============================================


// now check for email data log if needed, using state machine control to limit time when in this routine
if ((tm.hour == 0x00) && (tm.min == 0x00) && (MidNightLogFlag == FALSE))		//check for  midnight roll over and not just done it, (we have a 1 minute window to do this check)
	{
		if ((EmailDLogBusyFlag == FALSE) && (FunctionModule[EmailDLogEnableFlag].Status.Enabled == TRUE) && (EmailAlertBusyFlag == FALSE))		//check to make sure email is not currently busy doing something
		{
			//set the day pointer back one to email its data log info
			MidNightLogFlag = TRUE;		// indicate we are starting the mignight emailing data log
			ELogDay = dt.wday;
			if (ELogDay == 0x00)			//test for current new day being Sunday
				ELogDay = 6;			// if so, then day to log needs to be set to Sat = 6
					else				//else any other day correctly can be set to -1 from current day value
						ELogDay = ELogDay - 0x01;			//set day to log to current day just rolled over from
			SMTP_BMSdata();				//Send data log
		}
	}

if (EmailDLogBusyFlag == TRUE)
	SMTP_BMSdata();		//Continue with present SMTP states, still sending current email message

// The RequestLogNowFlagsWeb BYTE has multiple bits set by the web page requesting which days to log.  It is then used to set bits in the
// DataLogNowFlag BYTE has one bit at a time set to pass that information to the SMTP_BMSdata(); routine to select the correct day to gather data on.
if((RequestLogNowFlagsWeb > 0) & (MoreLogDays == TRUE))			//engage the email data logging now state machine if any bits are set (indicates what days to email data for)
{
	switch (DATALOG_NOW_STATE)		//each pass through the main loop processes some of the email request since it is of low priority
	{
		case DATALOG_NOW_HOME:										//nothing happening here, just get us started
			DATALOG_NOW_STATE++;
		break;
	
		case DATALOG_NOW_SUN:											//test for the Sunday bit being set		
			if (RequestLogNowFlagsWeb & 0x01)							//test for bit 0 set = Sun
			{
				MoreLogDays = FALSE;	//need to make this flag false so we only go through this loop after completing previous datalog email
				RequestLogNowFlagsWeb = RequestLogNowFlagsWeb & 0x7E;		//clear that bit in RequestLogNowFlagsWeb BYTE so we don't do it again next pass
				DataLogNowFlag = 0x01;								//enable data log, Sun bit-0 set
				Nop();
				SMTP_BMSdata();										//Send data log for that day
				break;
			}

		case DATALOG_NOW_MON:
			if (RequestLogNowFlagsWeb & 0x02)							//test for bit 1 set = Mon
			{
				MoreLogDays = FALSE;									//need to make this flag false so we only go through this loop after completing previous datalog email
				RequestLogNowFlagsWeb = RequestLogNowFlagsWeb & 0x7D;		//clear that bit in RequestLogNowFlagsWeb BYTE so we don't do it again next pass
				DataLogNowFlag = 0x02;								//enable data log, Mon bit-1 set
				SMTP_BMSdata();										//Send data log for that day
				break;
			}

		case DATALOG_NOW_TUE:
			if (RequestLogNowFlagsWeb & 0x04)							//test for bit 2 set = Tue
			{
				MoreLogDays = FALSE;									//need to make this flag false so we only go through this loop after completing previous datalog email
				RequestLogNowFlagsWeb = RequestLogNowFlagsWeb & 0x7B;		//clear that bit in RequestLogNowFlagsWeb BYTE so we don't do it again next pass
				DataLogNowFlag = 0x04;								//enable data log, Tue bit-2 set
				SMTP_BMSdata();										//Send data log for that day
				break;
			}

		case DATALOG_NOW_WED:
			if (RequestLogNowFlagsWeb & 0x08)							//test for bit 3 set = Wed
			{
				MoreLogDays = FALSE;									//need to make this flag false so we only go through this loop after completing previous datalog email
				RequestLogNowFlagsWeb = RequestLogNowFlagsWeb & 0x77;		//clear that bit in RequestLogNowFlagsWeb BYTE so we don't do it again next pass
				DataLogNowFlag = 0x08;								//enable data log, Wed bit-3 set
				SMTP_BMSdata();										//Send data log for that day
				break;
			}

		case DATALOG_NOW_THU:
			if (RequestLogNowFlagsWeb & 0x10)							//test for bit 4 set = Thu
			{
				MoreLogDays = FALSE;									//need to make this flag false so we only go through this loop after completing previous datalog email
				RequestLogNowFlagsWeb = RequestLogNowFlagsWeb & 0x6F;		//clear that bit in RequestLogNowFlagsWeb BYTE so we don't do it again next pass
				DataLogNowFlag = 0x10;								//enable data log, Thu bit-4 set
				SMTP_BMSdata();										//Send data log for that day
				break;
			}

		case DATALOG_NOW_FRI:
			if (RequestLogNowFlagsWeb & 0x20)							//test for bit 5 set = Fri
			{
				MoreLogDays = FALSE;									//need to make this flag false so we only go through this loop after completing previous datalog email
				RequestLogNowFlagsWeb = RequestLogNowFlagsWeb & 0x5F;		//clear that bit in RequestLogNowFlagsWeb BYTE so we don't do it again next pass
				DataLogNowFlag = 0x20;								//enable data log, Fri bit-5 set
				SMTP_BMSdata();										//Send data log for that day
				break;
			}

		case DATALOG_NOW_SAT:
			if (RequestLogNowFlagsWeb & 0x40)							//test for bit 6 set = Sat
			{
				MoreLogDays = FALSE;									//need to make this flag false so we only go through this loop after completing previous datalog email
				RequestLogNowFlagsWeb = RequestLogNowFlagsWeb & 0x3F;		//clear that bit in RequestLogNowFlagsWeb BYTE so we don't do it again next pass
				DataLogNowFlag = 0x40;								//enable data log, Sat bit-5 set
				SMTP_BMSdata();										//Send data log for that day
				break;
			}
		

		default:
		break;
	}//END switch (DataLogNowState)
 Nop();
}//END if (RequestLogNowFlagsWeb > 0)

//==========================

