//======================================================
//	BMS_DisplayClockSet.c
//	an include from: BMS_CustomApp.c
//	HTTPPrints for displaying clock while setting it
//======================================================

void HTTPPrint_ctyr(void)		//display currrent year, 
//		this routine must be called first before using other time display functions
{
	extern rtccTime tm;
	extern rtccDate dt;	
	BYTE TimeString[5];
Nop();
  	RtccGetTimeDate(&tm, &dt);	//update current time just once	
	TimeString[0] = '2';
	TimeString[1] = '0';
	TimeString[2] = ((dt.year & (0xF0))>>4) | (0x30);
	TimeString[3] = (dt.year & (0x0F)) | (0x30);
	TimeString[4] = '\0';
	TCPPutString(sktHTTP, TimeString);
}

void HTTPPrint_ctmo(void)		//display currrent year
{
	extern rtccDate dt;	
	BYTE TimeString[3];	
	TimeString[0] = ((dt.mon & (0xF0))>>4) | (0x30);
	TimeString[1] = (dt.mon & (0x0F)) | (0x30);
	TimeString[2] = '\0';
	TCPPutString(sktHTTP, TimeString);
}

void HTTPPrint_ctmd(void)		//display currrent year
{
	extern rtccDate dt;	
	BYTE TimeString[3];	
	TimeString[0] = ((dt.mday & (0xF0))>>4) | (0x30);
	TimeString[1] = (dt.mday & (0x0F)) | (0x30);
	TimeString[2] = '\0';
	TCPPutString(sktHTTP, TimeString);
}

void HTTPPrint_ctwd(void)		//display currrent year
{
	extern rtccDate dt;	
	BYTE TimeString[2];	
	TimeString[0] = (dt.wday & (0x0F)) | (0x30);
	TimeString[1] = '\0';
	TCPPutString(sktHTTP, TimeString);
}

void HTTPPrint_cthr(void)		//display currrent year
{
	extern rtccTime tm;	
	BYTE TimeString[3];	
	TimeString[0] = ((tm.hour & (0xF0))>>4) | (0x30);
	TimeString[1] = (tm.hour & (0x0F)) | (0x30);
	TimeString[2] = '\0';
	TCPPutString(sktHTTP, TimeString);
}

void HTTPPrint_ctmi(void)		//display currrent year
{
	extern rtccTime tm;	
	BYTE TimeString[3];	
	TimeString[0] = ((tm.min & (0xF0))>>4) | (0x30);
	TimeString[1] = (tm.min & (0x0F)) | (0x30);
	TimeString[2] = '\0';
	TCPPutString(sktHTTP, TimeString);
}

void HTTPPrint_ctse(void)		//display currrent year
{
	extern rtccTime tm;	
	BYTE TimeString[3];	
	TimeString[0] = ((tm.sec & (0xF0))>>4) | (0x30);
	TimeString[1] = (tm.sec & (0x0F)) | (0x30);
	TimeString[2] = '\0';
	TCPPutString(sktHTTP, TimeString);
}

void HTTPPrint_ctm1(void)		//displays a formatted time string
{
	extern rtccTime tm;
	extern rtccDate dt;	
	BYTE TimeString[11];
Nop();
  	RtccGetTimeDate(&tm, &dt);	//update current time just once	
	TimeString[0] = '2';
	TimeString[1] = '0';
	TimeString[2] = ((dt.year & (0xF0))>>4) | (0x30);
	TimeString[3] = (dt.year & (0x0F)) | (0x30);
	TimeString[4] = '-';
	TimeString[5] = ((dt.mon & (0xF0))>>4) | (0x30);
	TimeString[6] = (dt.mon & (0x0F)) | (0x30);
	TimeString[7] = '-';
	TimeString[8] = ((dt.mday & (0xF0))>>4) | (0x30);
	TimeString[9] = (dt.mday & (0x0F)) | (0x30);
	TimeString[10] = '\0';
	TCPPutString(sktHTTP, TimeString);
}

void HTTPPrint_ctm2(void)		//displays a formatted time string
{
	extern rtccTime tm;
	extern rtccDate dt;	
	BYTE TimeString[10];
//  	RtccGetTimeDate(&tm, &dt);	//update current time just once	
	TimeString[0] = ((tm.hour & (0xF0))>>4) | (0x30);
	TimeString[1] = (tm.hour & (0x0F)) | (0x30);
	TimeString[2] = ':';
	TimeString[3] = ((tm.min & (0xF0))>>4) | (0x30);
	TimeString[4] = (tm.min & (0x0F)) | (0x30);
	TimeString[5] = ':';
	TimeString[6] = ((tm.sec & (0xF0))>>4) | (0x30);
	TimeString[7] = (tm.sec & (0x0F)) | (0x30);
	TimeString[8] = '\0';
	TCPPutString(sktHTTP, TimeString);
}

void HTTPPrint_ctca(void)		//rtcc calibration setting
{
extern FUNCTION_RECORD FunctionModule[FunctionModuleSize];//RAM array that holds current sensor and function status and values 
	BYTE TimeString1[8];
	BYTE TimeString2[8];
	BYTE *s1 = TimeString1;
	BYTE *s2 = TimeString2;
	WORD Value;
	WORD NValue; 
	Value = FunctionModule[ErtccCalValue].DataValue1;
	if (Value & 0x0200)		//check for negitive value, bit 10 is sign
	{
		NValue = 512 - (Value & 0x01FF);	//find what the 10-bit neg value is
		uitoa(NValue, TimeString1);
		TimeString2[0] = '-';
		TimeString2[1] = '\0';
		strcat(s2, s1);	//format whit - sign first
		TCPPutString(sktHTTP, TimeString2);
		return;
	}
	uitoa(FunctionModule[ErtccCalValue].DataValue1, TimeString2);	//positive value, print as is	
	TCPPutString(sktHTTP, TimeString2);
}


