//================================================
//
//	BMS_EEPROM_RAM_utility.c
//  EEPROM copy routines
//	called from BMS_HTTPApp_util.c
//================================================
//


//Prototypes
void Eeprom_Write(unsigned char I2Cport, unsigned char DevAddress, unsigned char HighAdrByte, unsigned char LowAdrByte, unsigned char DataByte);
unsigned char Eeprom_Read(unsigned char I2Cport, unsigned char DevAddress, unsigned char HighAdrByte, unsigned char LowAdrByte);

void RAM_to_EEPROM_Copy(void)
{
unsigned char I2Cport;
unsigned char SlaveAddress;
unsigned char HighAddress;
unsigned char LowAddress;
unsigned char Data;
unsigned char StatusByte;
unsigned char Func_Num;
// In Main.c
//RAM array that holds current sensor and function status and values
	extern FUNCTION_RECORD FunctionModule[FunctionModuleSize];		//since index 0 is skipped,
										// make sure there is enough memory +1 from above #defines

I2Cport = 1;			//24LC512's are on I2C port 1
OpenI2C1( I2C_EN, BRG_VAL );	//open I2C channel 1 EEPROMs

SlaveAddress = 0x50;	//7-bit Serial EEPROM address, of first device, 
HighAddress = 0x00;		//starting addr hi
LowAddress = 0x00;		//starting addr Lo

Data = 0;
Func_Num = 0;
	Data_1_Memory_io = 0;			//set output to 0=Low for write enable

while (Func_Num < FunctionModuleSize)
	{
	Data = 0; 		//copy the Status byte first
	Data = FunctionModule[Func_Num].Status.AlarmUpper;
	Data = (Data <<1) | FunctionModule[Func_Num].Status.AlarmLower;
	Data = (Data <<1) | FunctionModule[Func_Num].Status.AlarmEnable;
	Data = (Data <<1) | FunctionModule[Func_Num].Status.Enabled;
	Data = (Data <<1) |  FunctionModule[Func_Num].Status.Installed;

	Eeprom_Write(I2Cport, SlaveAddress, HighAddress, LowAddress, Data);	//wite to EEPROM

	Data = Eeprom_Read(I2Cport, SlaveAddress, HighAddress, LowAddress);

	LowAddress ++;														//inc low byte addr
	if (LowAddress ==0)													//inc high if low rolled over
		HighAddress++;
//get next data in record
	Data = ((FunctionModule[Func_Num].Lowerlimit) & (0xFF00)) >> 8;		//get the high byte
	Eeprom_Write(I2Cport, SlaveAddress, HighAddress, LowAddress, Data);	//write the hi byte

	LowAddress ++;														//inc low byte addr
	if (LowAddress ==0)													//inc high if low rolled over
			HighAddress++;

	Data = ((FunctionModule[Func_Num].Lowerlimit) & (0x00FF));		//get the Lo byte
	Eeprom_Write(I2Cport, SlaveAddress, HighAddress, LowAddress, Data);	//write the hi byte

	LowAddress ++;														//inc low byte addr
	if (LowAddress ==0)													//inc high if low rolled over
		HighAddress++;

//get next data in record
	Data = ((FunctionModule[Func_Num].Upperlimit) & (0xFF00)) >> 8;		//get the high byte
	Eeprom_Write(I2Cport, SlaveAddress, HighAddress, LowAddress, Data);	//write the hi byte

	LowAddress ++;														//inc low byte addr
	if (LowAddress ==0)													//inc high if low rolled over
			HighAddress++;

	Data = ((FunctionModule[Func_Num].Upperlimit) & (0x00FF));		//get the Lo byte
	Eeprom_Write(I2Cport, SlaveAddress, HighAddress, LowAddress, Data);	//write the hi byte

	LowAddress ++;														//inc low byte addr
	if (LowAddress ==0)													//inc high if low rolled over
		HighAddress++;

//get next data in record
	Data = ((FunctionModule[Func_Num].DataValue1) & (0xFF00)) >> 8;		//get the high byte
	Eeprom_Write(I2Cport, SlaveAddress, HighAddress, LowAddress, Data);	//write the hi byte

	LowAddress ++;														//inc low byte addr
	if (LowAddress ==0)													//inc high if low rolled over
			HighAddress++;

	Data = ((FunctionModule[Func_Num].DataValue1) & (0x00FF));		//get the Lo byte
	Eeprom_Write(I2Cport, SlaveAddress, HighAddress, LowAddress, Data);	//write the hi byte

	LowAddress ++;														//inc low byte addr
	if (LowAddress ==0)													//inc high if low rolled over
		HighAddress++;

//get next data in record
	Data = ((FunctionModule[Func_Num].DataValue2) & (0xFF00)) >> 8;		//get the high byte
	Eeprom_Write(I2Cport, SlaveAddress, HighAddress, LowAddress, Data);	//write the hi byte

	LowAddress ++;														//inc low byte addr
	if (LowAddress ==0)													//inc high if low rolled over
			HighAddress++;

	Data = ((FunctionModule[Func_Num].DataValue2) & (0x00FF));		//get the Lo byte
	Eeprom_Write(I2Cport, SlaveAddress, HighAddress, LowAddress, Data);	//write the hi byte

	LowAddress ++;														//inc low byte addr
	if (LowAddress ==0)													//inc high if low rolled over
			HighAddress++;

Func_Num++;
	}
Data_1_Memory_io = 1;			//set output to 1=high for WP=protected
}

void EEPROM_to_RAM_Copy(void)
{
unsigned char I2Cport;
unsigned char SlaveAddress;
unsigned char HighAddress;
unsigned char LowAddress;
unsigned char Data;
unsigned char StatusByte;
unsigned char Func_Num;
// In Main.c
//RAM array that holds current sensor and function status and values
	extern FUNCTION_RECORD FunctionModule[FunctionModuleSize];		//since index 0 is skipped,
										// make sure there is enough memory +1 from above #defines

I2Cport = 1;			//24LC512's are on I2C port 1
OpenI2C1( I2C_EN, BRG_VAL );	//open I2C channel 1 EEPROMs

SlaveAddress = 0x50;	//7-bit Serial EEPROM address, of first device, 
HighAddress = 0x00;		//starting addr hi
LowAddress = 0x00;		//starting addr Lo

Data = 0;
Func_Num = 0;
	Data_1_Memory_io = 1;			//make sur output is 1=high for WP=protected

while (Func_Num < FunctionModuleSize)
	{

	Data = Eeprom_Read(I2Cport, SlaveAddress, HighAddress, LowAddress);			//Read the Status byte first
	FunctionModule[Func_Num].Status.Installed = Data & (0x01);			
	FunctionModule[Func_Num].Status.Enabled = (Data & (0x02)) >>1;
	FunctionModule[Func_Num].Status.AlarmEnable = (Data & (0x04)) >>2;
	FunctionModule[Func_Num].Status.AlarmLower = (Data & (0x08)) >>3;
	FunctionModule[Func_Num].Status.AlarmUpper = (Data & (0x10)) >>4;

	LowAddress ++;														//inc low byte addr
	if (LowAddress ==0)													//inc high if low rolled over
		HighAddress++;
	Data = Eeprom_Read(I2Cport, SlaveAddress, HighAddress, LowAddress);			//Read the Lowerlimit high byte first
	FunctionModule[Func_Num].Lowerlimit = Data <<8;

	LowAddress ++;														//inc low byte addr
	if (LowAddress ==0)													//inc high if low rolled over
			HighAddress++;
	FunctionModule[Func_Num].Lowerlimit =(FunctionModule[Func_Num].Lowerlimit) | Eeprom_Read(I2Cport, SlaveAddress, HighAddress, LowAddress);			//get the Lo byte next
//====
	LowAddress ++;														//inc low byte addr
	if (LowAddress ==0)													//inc high if low rolled over
		HighAddress++;
	Data = Eeprom_Read(I2Cport, SlaveAddress, HighAddress, LowAddress);			//Read the Lowerlimit high byte first
	FunctionModule[Func_Num].Upperlimit = Data <<8;

	LowAddress ++;														//inc low byte addr
	if (LowAddress ==0)													//inc high if low rolled over
			HighAddress++;
	FunctionModule[Func_Num].Upperlimit =(FunctionModule[Func_Num].Upperlimit) | Eeprom_Read(I2Cport, SlaveAddress, HighAddress, LowAddress);			//get the Lo byte next
//====
	LowAddress ++;														//inc low byte addr
	if (LowAddress ==0)													//inc high if low rolled over
		HighAddress++;
	Data = Eeprom_Read(I2Cport, SlaveAddress, HighAddress, LowAddress);			//Read the Lowerlimit high byte first
	FunctionModule[Func_Num].DataValue1 = Data <<8;

	LowAddress ++;														//inc low byte addr
	if (LowAddress ==0)													//inc high if low rolled over
			HighAddress++;
	FunctionModule[Func_Num].DataValue1 =(FunctionModule[Func_Num].DataValue1) | Eeprom_Read(I2Cport, SlaveAddress, HighAddress, LowAddress);			//get the Lo byte next
//====
	LowAddress ++;														//inc low byte addr
	if (LowAddress ==0)													//inc high if low rolled over
		HighAddress++;
	Data = Eeprom_Read(I2Cport, SlaveAddress, HighAddress, LowAddress);			//Read the Lowerlimit high byte first
	FunctionModule[Func_Num].DataValue2 = Data <<8;

	LowAddress ++;														//inc low byte addr
	if (LowAddress ==0)													//inc high if low rolled over
			HighAddress++;
	FunctionModule[Func_Num].DataValue2 =(FunctionModule[Func_Num].DataValue2) | Eeprom_Read(I2Cport, SlaveAddress, HighAddress, LowAddress);			//get the Lo byte next
	LowAddress ++;														//inc low byte addr
	if (LowAddress ==0)													//inc high if low rolled over
		HighAddress++;

	Func_Num++;		//repeat sam for the rest of the functions to copy
	}
Data_1_Memory_io = 1;			//set output to 1=high for WP=protected
}

