//===============================================================
//	BMS_GraphStats.c
//	State machine to test for alarms and send emails as configured
//	this file is an include file in "BMS_Graphs.c"
//===============================================================

static WORD MaxValue;		//needs to be here because value is used in multiple functions below

WORD MaxValueForRange(WORD Day, WORD StartHr, WORD StopHr)		//finds the Max value over the specified range
{
extern SENSORLOG_RECORD volatile DataLogDayArray[7][24][4];	//hive data array
extern WORD MaxValue;
WORD CurrentValue;
BYTE hourbar;
BYTE qhr;
WORD temp;

	switch(FUNCTION_TO_GRAPH)		//Function to graph
	{
	case gTTopInside:
	MaxValue = 0;
			for (hourbar = StartHr; hourbar <= StopHr; hourbar = hourbar +1)
			{
				for(qhr =0; qhr <= 3; qhr = qhr + 1)	//need to check each 1/4 hour for max value
				{
					CurrentValue = DataLogDayArray[Day][hourbar][qhr].cTTopInside;
						if(CurrentValue > MaxValue) 
							MaxValue = CurrentValue;
				}
			}	
	break;

	case gTTopOutside:
	MaxValue = 0;
			for (hourbar = StartHr; hourbar <= StopHr; hourbar = hourbar +1)
			{
				for(qhr =0; qhr <= 3; qhr = qhr + 1)	//need to check each 1/4 hour for max value
				{
					CurrentValue = DataLogDayArray[Day][hourbar][qhr].cTTopOutside;
						if(CurrentValue > MaxValue) 
							MaxValue = CurrentValue;
				}
			}	
	break;

	case gTBaseInside:
	MaxValue = 0;
			for (hourbar = StartHr; hourbar <= StopHr; hourbar = hourbar +1)
			{
				for(qhr =0; qhr <= 3; qhr = qhr + 1)	//need to check each 1/4 hour for max value
				{
					CurrentValue = DataLogDayArray[Day][hourbar][qhr].cTBaseInside;
						if(CurrentValue > MaxValue) 
							MaxValue = CurrentValue;
				}
			}	
	break;

	case gTBaseOutSide:
	MaxValue = 0;
			for (hourbar = StartHr; hourbar <= StopHr; hourbar = hourbar +1)
			{
				for(qhr =0; qhr <= 3; qhr = qhr + 1)	//need to check each 1/4 hour for max value
				{
					CurrentValue = DataLogDayArray[Day][hourbar][qhr].cTBaseOutSide;
						if(CurrentValue > MaxValue) 
							MaxValue = CurrentValue;
				}
			}	
	break;

	case gHumidity:
	MaxValue = 0;
			for (hourbar = StartHr; hourbar <= StopHr; hourbar = hourbar +1)
			{
				for(qhr =0; qhr <= 3; qhr = qhr + 1)	//need to check each 1/4 hour for max value
				{
					CurrentValue = DataLogDayArray[Day][hourbar][qhr].cHumidity;
						if(CurrentValue > MaxValue) 
							MaxValue = CurrentValue;
				}
			}	
	break;

	case gDayLight:
	MaxValue = 0;
			for (hourbar = StartHr; hourbar <= StopHr; hourbar = hourbar +1)
			{
				for(qhr =0; qhr <= 3; qhr = qhr + 1)	//need to check each 1/4 hour for max value
				{
					CurrentValue = DataLogDayArray[Day][hourbar][qhr].cDayLight;
						if(CurrentValue > MaxValue) 
							MaxValue = CurrentValue;
				}
			}	
	break;

	case gBeeTrafficOut:
	MaxValue = 0;
			for (hourbar = StartHr; hourbar <= StopHr; hourbar = hourbar +1)
			{	
				CurrentValue = 0;
				for(qhr =0; qhr <= 3; qhr = qhr + 1)	//need to add the four readings in the case of bee traffic each hour for total
				{
					temp = DataLogDayArray[Day][hourbar][qhr].cBeeTrafficOut;	//Add up the 4 qtr hr readings for the hour total
					CurrentValue = CurrentValue + temp;
				}
				if(CurrentValue > MaxValue) 
					MaxValue = CurrentValue;
			}
	break;

	case gBeeTrafficIn:
	MaxValue = 0;
			for (hourbar = StartHr; hourbar <= StopHr; hourbar = hourbar +1)
			{	
				CurrentValue = 0;
				for(qhr =0; qhr <= 3; qhr = qhr + 1)	//need to add the four readings in the case of bee traffic each hour for total
				{
					temp = DataLogDayArray[Day][hourbar][qhr].cBeeTrafficIn;	//Add up the 4 qtr hr readings for the hour total
					CurrentValue = CurrentValue + temp;
				}
				if(CurrentValue > MaxValue) 
					MaxValue = CurrentValue;
			}
	break;
	



	default:
	break;
	}//END switch(gFunc)
return MaxValue;
}//END MaxValueForRange(WORD Day, WORD StartHr, WORD StopHr)

//=========================

WORD MinValueForRange(WORD Day, WORD StartHr, WORD StopHr)		//finds the Min value over the specified range
{
extern SENSORLOG_RECORD volatile DataLogDayArray[7][24][4];	//hive data array
WORD MinValue;
WORD CurrentValue;
BYTE hourbar;
BYTE qhr;
WORD temp;

	switch(FUNCTION_TO_GRAPH)		//Function to graph
	{
	case gTTopInside:
	MinValue = MaxValue;
			for (hourbar = StartHr; hourbar <= StopHr; hourbar = hourbar +1)
			{
				for(qhr =0; qhr <= 3; qhr = qhr + 1)	//need to check each 1/4 hour for min value
				{
					CurrentValue = DataLogDayArray[Day][hourbar][qhr].cTTopInside;
					if(CurrentValue < MinValue) 
						MinValue = CurrentValue;
				}
			}
	break;

	case gTTopOutside:
	MinValue = MaxValue;
			for (hourbar = StartHr; hourbar <= StopHr; hourbar = hourbar +1)
			{
				for(qhr =0; qhr <= 3; qhr = qhr + 1)	//need to check each 1/4 hour for min value
				{
					CurrentValue = DataLogDayArray[Day][hourbar][qhr].cTTopOutside;
					if(CurrentValue < MinValue) 
						MinValue = CurrentValue;
				}
			}
	break;

	case gTBaseInside:
	MinValue = MaxValue;
			for (hourbar = StartHr; hourbar <= StopHr; hourbar = hourbar +1)
			{
				for(qhr =0; qhr <= 3; qhr = qhr + 1)	//need to check each 1/4 hour for min value
				{
					CurrentValue = DataLogDayArray[Day][hourbar][qhr].cTBaseInside;
					if(CurrentValue < MinValue) 
						MinValue = CurrentValue;
				}
			}
	break;

	case gTBaseOutSide:
	MinValue = MaxValue;
			for (hourbar = StartHr; hourbar <= StopHr; hourbar = hourbar +1)
			{
				for(qhr =0; qhr <= 3; qhr = qhr + 1)	//need to check each 1/4 hour for min value
				{
					CurrentValue = DataLogDayArray[Day][hourbar][qhr].cTBaseOutSide;
					if(CurrentValue < MinValue) 
						MinValue = CurrentValue;
				}
			}
	break;

	case gHumidity:
	MinValue = MaxValue;
			for (hourbar = StartHr; hourbar <= StopHr; hourbar = hourbar +1)
			{
				for(qhr =0; qhr <= 3; qhr = qhr + 1)	//need to check each 1/4 hour for min value
				{
					CurrentValue = DataLogDayArray[Day][hourbar][qhr].cHumidity;
					if(CurrentValue < MinValue) 
						MinValue = CurrentValue;
				}
			}
	break;

	case gDayLight:
	MinValue = MaxValue;
			for (hourbar = StartHr; hourbar <= StopHr; hourbar = hourbar +1)
			{
				for(qhr =0; qhr <= 3; qhr = qhr + 1)	//need to check each 1/4 hour for max value
				{
					CurrentValue = DataLogDayArray[Day][hourbar][qhr].cDayLight;
						if(CurrentValue < MinValue) 
							MinValue = CurrentValue;
				}
			}	
	break;

	case gBeeTrafficOut:
	MinValue = MaxValue;
			for (hourbar = StartHr; hourbar <= StopHr; hourbar = hourbar +1)
			{	
				CurrentValue = 0;
				for(qhr =0; qhr <= 3; qhr = qhr + 1)	//need to add the four readings in the case of bee traffic each hour for total
				{
					temp = DataLogDayArray[Day][hourbar][qhr].cBeeTrafficOut;	//Add up the 4 qtr hr readings for the hour total
					CurrentValue = CurrentValue + temp;
				}
				if(CurrentValue < MinValue) 
					MinValue = CurrentValue;
			}
	break;

	case gBeeTrafficIn:
	MinValue = MaxValue;
			for (hourbar = StartHr; hourbar <= StopHr; hourbar = hourbar +1)
			{	
				CurrentValue = 0;
				for(qhr =0; qhr <= 3; qhr = qhr + 1)	//need to add the four readings in the case of bee traffic each hour for total
				{
					temp = DataLogDayArray[Day][hourbar][qhr].cBeeTrafficIn;	//Add up the 4 qtr hr readings for the hour total
					CurrentValue = CurrentValue + temp;
				}
				if(CurrentValue < MinValue) 
					MinValue = CurrentValue;
			}
	break;


	default:
	break;
	}//END switch(gFunc)
return MinValue;
}//END MinValueForRange(WORD Day, WORD StartHr, WORD StopHr)

//=========================

WORD AvgValueForRange(WORD Day, WORD StartHr, WORD StopHr)		////calculates the Average value over the specified range
{
extern SENSORLOG_RECORD volatile DataLogDayArray[7][24][4];	//hive data array
WORD AvgValue;
DWORD AvgValueC;
DWORD ACount;
WORD CurrentValue;
BYTE hourbar;
BYTE qhr;
WORD temp;
DWORD Dtemp;

	switch(FUNCTION_TO_GRAPH)		//Function to graph
	{
	case gTTopInside:
	AvgValueC = 0;
	ACount = 0;
			for (hourbar = StartHr; hourbar <= StopHr; hourbar = hourbar +1)
			{	
				for(qhr =0; qhr <= 3; qhr = qhr + 1)	//need to add in each 1/4 hour for avg value
				{
					CurrentValue = DataLogDayArray[Day][hourbar][qhr].cTTopInside;				
					AvgValueC += (DWORD) CurrentValue;
					ACount++;
				}
			}
			Dtemp = AvgValueC / ACount;		//Calculate the average from the total now
			AvgValue = (WORD)Dtemp;
	break;

	case gTTopOutside:
	AvgValueC = 0;
	ACount = 0;
			for (hourbar = StartHr; hourbar <= StopHr; hourbar = hourbar +1)
			{	
				for(qhr =0; qhr <= 3; qhr = qhr + 1)	//need to add in each 1/4 hour for avg value
				{
					CurrentValue = DataLogDayArray[Day][hourbar][qhr].cTTopOutside;				
					AvgValueC += (DWORD) CurrentValue;
					ACount++;
				}
			}
			Dtemp = AvgValueC / ACount;		//Calculate the average from the total now
			AvgValue = (WORD)Dtemp;
	break;

	case gTBaseInside:
	AvgValueC = 0;
	ACount = 0;
			for (hourbar = StartHr; hourbar <= StopHr; hourbar = hourbar +1)
			{	
				for(qhr =0; qhr <= 3; qhr = qhr + 1)	//need to add in each 1/4 hour for avg value
				{
					CurrentValue = DataLogDayArray[Day][hourbar][qhr].cTBaseInside;				
					AvgValueC += (DWORD) CurrentValue;
					ACount++;
				}
			}
			Dtemp = AvgValueC / ACount;		//Calculate the average from the total now
			AvgValue = (WORD)Dtemp;
	break;

	case gTBaseOutSide:
	AvgValueC = 0;
	ACount = 0;
			for (hourbar = StartHr; hourbar <= StopHr; hourbar = hourbar +1)
			{	
				for(qhr =0; qhr <= 3; qhr = qhr + 1)	//need to add in each 1/4 hour for avg value
				{
					CurrentValue = DataLogDayArray[Day][hourbar][qhr].cTBaseOutSide;				
					AvgValueC += (DWORD) CurrentValue;
					ACount++;
				}
			}
			Dtemp = AvgValueC / ACount;		//Calculate the average from the total now
			AvgValue = (WORD)Dtemp;
	break;

	case gHumidity:
	AvgValueC = 0;
	ACount = 0;
			for (hourbar = StartHr; hourbar <= StopHr; hourbar = hourbar +1)
			{	
				for(qhr =0; qhr <= 3; qhr = qhr + 1)	//need to add in each 1/4 hour for avg value
				{
					CurrentValue = DataLogDayArray[Day][hourbar][qhr].cHumidity;				
					AvgValueC += (DWORD) CurrentValue;
					ACount++;
				}
			}
			Dtemp = AvgValueC / ACount;		//Calculate the average from the total now
			AvgValue = (WORD)Dtemp;
	break;
	
	case gDayLight:
	AvgValueC = 0;
	ACount = 0;
			for (hourbar = StartHr; hourbar <= StopHr; hourbar = hourbar +1)
			{	
				for(qhr =0; qhr <= 3; qhr = qhr + 1)	//need to add in each 1/4 hour for avg value
				{
					CurrentValue = DataLogDayArray[Day][hourbar][qhr].cDayLight;				
					AvgValueC += (DWORD) CurrentValue;
					ACount++;
				}
			}
			Dtemp = AvgValueC / ACount;		//Calculate the average from the total now
			AvgValue = (WORD)Dtemp;
	break;

	case gBeeTrafficOut:
	AvgValueC = 0;
	ACount = 0;
			for (hourbar = StartHr; hourbar <= StopHr; hourbar = hourbar +1)
			{	
				CurrentValue = 0;
				for(qhr =0; qhr <= 3; qhr = qhr + 1)	//need to add the four readings in the case of bee traffic each hour for total
				{
					temp = DataLogDayArray[Day][hourbar][qhr].cBeeTrafficOut;	//Add up the 4 qtr hr readings for the hour total
					CurrentValue = CurrentValue + temp;
				}
				AvgValueC += (DWORD) CurrentValue;
				ACount++;

			}
			Dtemp = AvgValueC / ACount;		//Calculate the average from the total now
			AvgValue = (WORD)Dtemp;
	break;

	case gBeeTrafficIn:
	AvgValueC = 0;
	ACount = 0;
			for (hourbar = StartHr; hourbar <= StopHr; hourbar = hourbar +1)
			{	
				CurrentValue = 0;
				for(qhr =0; qhr <= 3; qhr = qhr + 1)	//need to add the four readings in the case of bee traffic each hour for total
				{
					temp = DataLogDayArray[Day][hourbar][qhr].cBeeTrafficIn;	//Add up the 4 qtr hr readings for the hour total
					CurrentValue = CurrentValue + temp;
				}
				AvgValueC += (DWORD) CurrentValue;
				ACount++;

			}
			Dtemp = AvgValueC / ACount;		//Calculate the average from the total now
			AvgValue = (WORD)Dtemp;
	break;

	default:
	break;
	}//END switch(gFunc)
return AvgValue;
}//END MinValueForRange(WORD Day, WORD StartHr, WORD StopHr)

//===================================================================

void FormatResultString(WORD GraphFunction)
{
extern BYTE ResultString[16];
extern WORD ResultValue;
BYTE ResultLength;
	switch(GraphFunction)
	{
		case gTBaseOutSide:
		case gTBaseInside:
		case gTTopOutside:
		case gTTopInside:
			MCP9800_12bit_format(ResultValue);
		break;

		case gHumidity:
		case gDayLight:
		ResultLength = strlen(ResultString);
		if (ResultLength > 1)
		{
			ResultString[ResultLength] = ResultString[ResultLength-1];
			ResultString[ResultLength-1] = '.';
			ResultString[ResultLength+1] = '%';
			ResultString[ResultLength+2] = '\0';
		}
		break;

/*		case gDayLight:
		ResultLength = strlen(ResultString);
		if (ResultLength > 1)
		{
			ResultString[ResultLength] = ResultString[ResultLength-1];
			ResultString[ResultLength-1] = '.';
			ResultString[ResultLength+1] = '%';
			ResultString[ResultLength+2] = '\0';
		}
		break;
*/
		case gBeeTrafficOut:
		break;

		case gBeeTrafficIn:
		break;

		default:
		break;
	}
}

