//====================================================================
//	BMS_SMTPdata.c
//	sends emails for data logging
//====================================================================

/*********************************************************************
 *
 *
 *********************************************************************
 * FileName:        SMTPDemo.c  ==> BMS_SMTPdatalog.c ==> BMS_SMTPdata.c
 ********************************************************************/
#define __SMTPDATA_C

#include "TCPIP Stack/TCPIP.h"
#include "MainDemo.h"
#include "BMS_Globals.h"
#include "BMS_hardwareConfig.h"
#include <string.h>
//#include "GenericTypeDefs.h"



extern FUNCTION_RECORD volatile FunctionModule[FunctionModuleSize];
// Email buffers
extern  BYTE EMtoStr[40];			//email to address
extern  BYTE EMfromStr[40];			//email from string
extern  BYTE EMStrBody[80];			//email message
extern  BYTE EMSubject[80];			//suject text
extern  BYTE EMServer[40];			//email server
extern BYTE EmailAlertBusyFlag;		//Indicates if there is an alert email is process
extern BYTE EmailDLogBusyFlag;		//Indicates if there is an data log email is process
extern BYTE RequestLogNowFlagsWeb;		//bits set by web page requesting days to email data log info for
extern BYTE SubjectID;				//email subject ID
extern BOOL MoreLogDays;			//flag to keep track of where we are at in email process in sending data logs
/*****************************************************************************
  Function:
	void SMTPdata(void)

  Summary:
	Send data log using the e-mail (SMTP) client.
	
  Description:
	While the client is executing, the RED system status LED will be used as a busy indicator.  
		
  Precondition:
	The SMTP client is initialized.

  Parameters:
	None

  Returns:
  	None
  ***************************************************************************/
#if defined(STACK_USE_SMTP_CLIENT)
void SMTP_BMSdata(void)			//was renamed from SMTPDemo
{
extern SENSORLOG_RECORD volatile DataLogDayArray[7][24][4]; // Hourly reading every 15min (1/4hr)
extern 	rtccTime tm;		// time structure
extern	rtccDate dt;		// date structure
extern  BYTE RequestLogNowFlags;		//bits set by web page requesting days to email data log info for
extern BYTE DataLogNowFlag;			//Indicates if there is an immediate request for emailing a data log dump
extern BOOL MoreLogDays;			//flag to keep track of where we are at in email process in sending data logs
extern BYTE ELogDay;				//day to use for data log info in memory

static enum		//states for emailing
{
	DATA_HOME = 0,
	DATA_BEGIN,
	DATA_PUT_DATA_ID,
	DATA_PUT_DATA2,
	DATA_SMTP_FINISHING,
	DATA_DONE
} DataState = DATA_HOME;

static TICK WaitTime;

static BYTE TimeString[11];

 
if (DataState == DATA_HOME)
{
	DataID = DATA_ID_HOME;
}
      
switch(DataState)
{
	case DATA_HOME:
	{
		// Start sending an email
		EmailDLogBusyFlag = TRUE;	//set RED System Status LED on to indicate we are doing a data log email
		DataID++;					//bump to the first data set to log
		DataState++;				//bump to next email state 
	}
	break;

	case DATA_BEGIN:
		if(SMTPBeginUsage())
		{
			// Note that these strings must stay allocated in 
			// memory until SMTPIsBusy() returns FALSE.  To 
			// guarantee that the C compiler does not reuse this 
			// memory, you must allocate the strings as static.

				static BYTE RAMStringTo[] = "hive1@beelab.com";	
				static BYTE RAMStringBody[] = "Message generated by SMTP DATA LOG Service";

				SMTPClient.Server.szROM = (ROM BYTE*)"mail.beelab.com";	// SMTP server address, works
				SMTPClient.ROMPointers.Server = 1;
				SMTPClient.To.szRAM = RAMStringTo;
				SMTPClient.From.szROM = (ROM BYTE*)"HIVE-1 <hive1@beelab.com>";
				SMTPClient.ROMPointers.From = 1;

				SMTPClient.Subject.szROM = (ROM BYTE*)"HIVE-1_DATA_LOG";
				SMTPClient.ROMPointers.Subject = 1;

				SMTPSendMail();
				DataState++;
			}
		break;

	case DATA_PUT_DATA_ID:
		// Check to see if a failure occured
		if(!SMTPIsBusy())
		{
			// Finished sending mail
			DataState = DATA_DONE;
			WaitTime = TickGet();
			(SMTPEndUsage() == SMTP_SUCCESS);
		break;
		}
		
//format time stamp information header
		if(SMTPIsPutReady() >= 68u)	//message length
		{
//====== day selection to email here

if (DataLogNowFlag > 0)
	{
		if (DataLogNowFlag & 0x01)							//test for bit 0 set = Sun
			{
				ELogDay = 0;
				DataLogNowFlag = DataLogNowFlag & 0x7E;		//clear that bit in DataLogNowFlag
			}

		if (DataLogNowFlag & 0x02)							//test for bit 1 set = Mon
			{
				ELogDay = 1;
				DataLogNowFlag = DataLogNowFlag & 0x7D;		//clear that bit in DataLogNowFlag
			}

		if (DataLogNowFlag & 0x04)							//test for bit 2 set = Tue
			{
				ELogDay = 2;
				DataLogNowFlag = DataLogNowFlag & 0x7B;		//clear that bit in DataLogNowFlag
			}

		if (DataLogNowFlag & 0x08)							//test for bit 3 set = Wed
			{
				ELogDay = 3;
				DataLogNowFlag = DataLogNowFlag & 0x77;		//clear that bit in DataLogNowFlag
			}

		if (DataLogNowFlag & 0x10)							//test for bit 4 set = Thu
			{
				ELogDay = 4;
				DataLogNowFlag = DataLogNowFlag & 0x6F;		//clear that bit in DataLogNowFlag
			}

		if (DataLogNowFlag & 0x20)							//test for bit 5 set = Fri
			{
				ELogDay = 5;
				DataLogNowFlag = DataLogNowFlag & 0x5F;		//clear that bit in DataLogNowFlag
			}

		if (DataLogNowFlag & 0x40)							//test for bit 6 set = Sat
			{
				ELogDay = 6;
				DataLogNowFlag = DataLogNowFlag & 0x3F;		//clear that bit in DataLogNowFlag
			}
	}

//                                                         |<==start of fixed characters
//														   |
//								 012345678901234567890123456789012345678901234567890123456789012345678
//		BYTE RAMStringBody[] = 	"                  data log for: ddd 20xx-xx-xx / xx:xx:xx,\r\n";
		BYTE RAMStringBody[] = 	"                  data log for: ddd | Sent 20xx-xx-xx / xx:xx:xx,\r\n";
		BYTE       Spaces18[] = "                  ";

  		RtccGetTimeDate(&tm, &dt);	//update current time just once	

		RAMStringBody[45] = ((dt.year & (0xF0))>>4) | (0x30);		// year, tens digit
		RAMStringBody[46] = (dt.year & (0x0F)) | (0x30);			// year, ones digit
		RAMStringBody[48] = ((dt.mon & (0xF0))>>4) | (0x30);		// month, tens digit
		RAMStringBody[49] = (dt.mon & (0x0F)) | (0x30);				// month, ones digit
		RAMStringBody[51] = ((dt.mday & (0xF0))>>4) | (0x30);		// mday, tens digit
		RAMStringBody[52] = (dt.mday & (0x0F)) | (0x30);			// mday, ones digit

		RAMStringBody[56] = ((tm.hour & (0xF0))>>4) | (0x30);		// hours, tens digit
		RAMStringBody[57] = (tm.hour & (0x0F)) | (0x30);			// hours, ones digit
		RAMStringBody[59] = ((tm.min & (0xF0))>>4) | (0x30);		// minutes, tens digit
		RAMStringBody[60] = (tm.min & (0x0F)) | (0x30);				// minutes, ones digit
		RAMStringBody[62] = ((tm.sec & (0xF0))>>4) | (0x30);		// seconds, tens digit
		RAMStringBody[63] = (tm.sec & (0x0F)) | (0x30);				// seconds, ones digit

		switch(ELogDay)		//figure out the day of the week to fill in for easy reading
		{
			case 0:
				RAMStringBody[32] = 'S';	// wday, 1st char
				RAMStringBody[33] = 'u';	// wday, 2nd char
				RAMStringBody[34] = 'n';	// wday, 3rd char
			break;

			case 1:
				RAMStringBody[32] = 'M';	// wday, 1st char
				RAMStringBody[33] = 'o';	// wday, 2nd char
				RAMStringBody[34] = 'n';	// wday, 3rd char
			break;

			case 2:
				RAMStringBody[32] = 'T';	// wday, 1st char
				RAMStringBody[33] = 'u';	// wday, 2nd char
				RAMStringBody[34] = 'e';	// wday, 3rd char
			break;

			case 3:
				RAMStringBody[32] = 'W';	// wday, 1st char
				RAMStringBody[33] = 'e';	// wday, 2nd char
				RAMStringBody[34] = 'd';	// wday, 3rd char
			break;

			case 4:
				RAMStringBody[32] = 'T';	// wday, 1st char
				RAMStringBody[33] = 'h';	// wday, 2nd char
				RAMStringBody[34] = 'u';	// wday, 3rd char
			break;

			case 5:
				RAMStringBody[32] = 'F';	// wday, 1st char
				RAMStringBody[33] = 'r';	// wday, 2nd char
				RAMStringBody[34] = 'i';	// wday, 3rd char
			break;

			case 6:
				RAMStringBody[32] = 'S';	// wday, 1st char
				RAMStringBody[33] = 'a';	// wday, 2nd char
				RAMStringBody[34] = 't';	// wday, 3rd char
			break;
		}//END switch(ELogDay)


		switch(DataID)
		{
			case DATA_ID_BEEOUT:								//Bee Traffic Out
				strncpy(RAMStringBody, Spaces18, 18);			//clear buffer space that gets written over
				strncpy(RAMStringBody, "Out_Traffic", 11);
			break;

			case DATA_ID_BEEIN:									//Bee Traffic In
				strncpy(RAMStringBody, Spaces18, 18);			//clear buffer space that gets written over
				strncpy(RAMStringBody, "In_Traffic", 10);
			break;

			case DATA_ID_DAYLIGHT:								//Daylight sensor
				strncpy(RAMStringBody, Spaces18, 18);			//clear buffer space that gets written over
				strncpy(RAMStringBody, "Daylight", 8);
			break;	

			case DATA_ID_TBO:									//Temperature Base Outside
				strncpy(RAMStringBody, Spaces18, 18);			//clear buffer space that gets written over
				strncpy(RAMStringBody, "T-Base_Outside", 14);
			break;	

			case DATA_ID_TBI:									//Temperature Base Inside
				strncpy(RAMStringBody, Spaces18, 18);			//clear buffer space that gets written over
				strncpy(RAMStringBody, "T-Base_Inside", 13);
			break;

			case DATA_ID_TTO:									//Temperature Top Outside
				strncpy(RAMStringBody, Spaces18, 18);			//clear buffer space that gets written over
				strncpy(RAMStringBody, "T-Top_Outside", 13);
			break;

			case DATA_ID_TTI:									//Temperature Top Inside
				strncpy(RAMStringBody, Spaces18, 18);			//clear buffer space that gets written over
				strncpy(RAMStringBody, "T-Top_Inside", 12);
			break;

			case DATA_ID_HH:									//Hive Humidity
				strncpy(RAMStringBody, Spaces18, 18);			//clear buffer space that gets written over
				strncpy(RAMStringBody, "Hive_Humidity", 13);
			break;		
			
			default:
			break;
		}//END switch(DataID)

		SMTPPutString(RAMStringBody);
		DataState++;

		}//END if(SMTPIsPutReady() >= 61u)	//message length
		break;
	//END case DATA_PUT_DATA_ID

	break;		
	
	case DATA_PUT_DATA2:
		// Check to see if a failure occured
		if(!SMTPIsBusy())
		{
			// Finished sending mail
			DataState = DATA_DONE;
			WaitTime = TickGet();
			(SMTPEndUsage() == SMTP_SUCCESS);
			break;
		}
		
		if(SMTPIsPutReady() >= 160u)
		{

	static BYTE hourbar;
	static BYTE qhr;
	static DWORD Dtemp;
	static DWORD HourData;
	static BYTE Result[12];
	DWORD AvgValueC;
	DWORD ACount;
	DWORD CurrentValue;

	for (hourbar = 0; hourbar <= 23; hourbar = hourbar +1)
	{	
		switch(DataID)
		{
			case DATA_ID_BEEOUT:			//Bee Traffic Out
				HourData = 0;
				for(qhr =0; qhr <= 3; qhr = qhr + 1)	//need to add the four readings in the case of bee traffic each hour for total
					{
						Dtemp = DataLogDayArray[ELogDay][hourbar][qhr].cBeeTrafficOut;
						HourData = HourData + Dtemp;
					}
			break;

			case DATA_ID_BEEIN:			//Bee Traffic In
				HourData = 0;
				for(qhr =0; qhr <= 3; qhr = qhr + 1)	//need to add the four readings in the case of bee traffic each hour for total
					{
						Dtemp = DataLogDayArray[ELogDay][hourbar][qhr].cBeeTrafficIn;
						HourData = HourData + Dtemp;
					}
			break;

			case DATA_ID_DAYLIGHT:		//Daylight sensor
				AvgValueC = 0;
				ACount = 0;
				for(qhr =0; qhr <= 3; qhr = qhr + 1)	//need to add in each 1/4 hour for avg value
				{
					CurrentValue = DataLogDayArray[ELogDay][hourbar][qhr].cDayLight;				
					AvgValueC += (DWORD) CurrentValue;
					ACount++;
				}
			Dtemp = AvgValueC / ACount;		//Calculate the average from the total now
			HourData = (WORD)Dtemp;
			break;

			case DATA_ID_TBO:			//Temperature Base Outside
				AvgValueC = 0;
				ACount = 0;
				for(qhr =0; qhr <= 3; qhr = qhr + 1)	//need to add in each 1/4 hour for avg value
				{
					CurrentValue = DataLogDayArray[ELogDay][hourbar][qhr].cTBaseOutSide;				
					AvgValueC += (DWORD) CurrentValue;
					ACount++;
				}
			Dtemp = AvgValueC / ACount;		//Calculate the average from the total now
			HourData = (WORD)Dtemp;
			break;

			case DATA_ID_TBI:			//Temperature Base Inside
				AvgValueC = 0;
				ACount = 0;
				for(qhr =0; qhr <= 3; qhr = qhr + 1)	//need to add in each 1/4 hour for avg value
				{
					CurrentValue = DataLogDayArray[ELogDay][hourbar][qhr].cTBaseInside;			
					AvgValueC += (DWORD) CurrentValue;
					ACount++;
				}
			Dtemp = AvgValueC / ACount;		//Calculate the average from the total now
			HourData = (WORD)Dtemp;
			break;

			case DATA_ID_TTO:			//Temperature Top Outside
				AvgValueC = 0;
				ACount = 0;
				for(qhr =0; qhr <= 3; qhr = qhr + 1)	//need to add in each 1/4 hour for avg value
				{
					CurrentValue = DataLogDayArray[ELogDay][hourbar][qhr].cTTopOutside;			
					AvgValueC += (DWORD) CurrentValue;
					ACount++;
				}
			Dtemp = AvgValueC / ACount;		//Calculate the average from the total now
			HourData = (WORD)Dtemp;
			break;

			case DATA_ID_TTI:			//Temperature Top Inside
				AvgValueC = 0;
				ACount = 0;
				for(qhr =0; qhr <= 3; qhr = qhr + 1)	//need to add in each 1/4 hour for avg value
				{
					CurrentValue = DataLogDayArray[ELogDay][hourbar][qhr].cTTopInside;		
					AvgValueC += (DWORD) CurrentValue;
					ACount++;
				}
			Dtemp = AvgValueC / ACount;		//Calculate the average from the total now
			HourData = (WORD)Dtemp;
			break;

			case DATA_ID_HH:				//Hive Humidity
				AvgValueC = 0;
				ACount = 0;
				for(qhr =0; qhr <= 3; qhr = qhr + 1)	//need to add in each 1/4 hour for avg value
				{
					CurrentValue = DataLogDayArray[ELogDay][hourbar][qhr].cHumidity;	
					AvgValueC += (DWORD) CurrentValue;
					ACount++;
				}
			Dtemp = AvgValueC / ACount;		//Calculate the average from the total now
			HourData = (WORD)Dtemp;
			break;

		}//END switch(DataID)

		uitoa(HourData, Result);
		SMTPPutString(Result);
		SMTPPut(',');
		SMTPPut(' ');
		SMTPFlush();
	}//END for (hourbar = 0; hourbar <= 23; hourbar = hourbar +1)

	SMTPPut('\r');
	SMTPPut('\n');
	SMTPPut('\r');
	SMTPPut('\n');
	SMTPFlush();

	DataID++;
	DataState = DATA_PUT_DATA_ID;		//set back one state in case there are more data sets to email next pass through

	if (DataID == DATA_ID_DONE)			//if this was last data set, then move on to next DataState to finish
	{
		if (RequestLogNowFlagsWeb > 0)		//test for more days to send data for next pass
		{
 //			DataLogNowFlag = 0;			//clear the current day selected, but there are more days to go
			DataID = DATA_ID_HOME + 1;
//			DataState = DATA_PUT_DATA_ID;		//set back one state in case there are more data sets to email next pass through
			MoreLogDays = TRUE;			//flag to keep track of where we are at in email process in sending data logs	
		} 
			else
			{
				SMTPPutDone();
				DataState = DATA_SMTP_FINISHING;
			}
	}

			}//END if(SMTPIsPutReady() >= 120u)
	break;	//END case DATA_PUT_DATA2:


	case DATA_SMTP_FINISHING:	
		// Check to see if we are done communicating with the SMTP server
		if(!SMTPIsBusy())
		{
			// Finished sending mail
			DataState = DATA_DONE;
			WaitTime = TickGet();
			(SMTPEndUsage() == SMTP_SUCCESS);
		}
	break;	//END case DATA_SMTP_FINISHING:

	case DATA_DONE:
		MoreLogDays = TRUE;			//reset this flag true to allow new data log files to be sent
		EmailDLogBusyFlag = FALSE;
		DataState = DATA_HOME;	
		// Wait for the user to release BUTTON2 or BUTTON3 and for at 
		// least 1 second to pass before allowing another 
		// email to be sent.  This is merely to prevent 
		// accidental flooding of email boxes while 
		// developing code.  Your application may wish to 
			// remove this.
		//	if(BUTTON_SW1_IO && BUTTON_SW2_IO)
	//		{
	//			if(TickGet() - WaitTime > TICK_SECOND)
	//			{
	//				MailState = MAIL_HOME;
	//			}
	//		}
	break;	//END case DATA_DONE:
	}
//}
}//END switch(DataState)

#endif //#if defined(STACK_USE_SMTP_CLIENT)


