//================================================
//
//	BMS_dEEPROM_dRAM_utility.c
//  EEPROM copy routines
//	called from BMS_HTTPApp_util.c
//================================================
//


//Prototypes
void Eeprom_Write(unsigned char I2Cport, unsigned char DevAddress, unsigned char HighAdrByte, unsigned char LowAdrByte, unsigned char DataByte);
unsigned char Eeprom_Read(unsigned char I2Cport, unsigned char DevAddress, unsigned char HighAdrByte, unsigned char LowAdrByte);

void dRAM_to_dEEPROM_Copy(void)
{
unsigned char I2Cport;
unsigned char SlaveAddress;
unsigned char HighAddress;
unsigned char LowAddress;
unsigned char Data;
unsigned char StatusByte;
unsigned char Func_Num;

BYTE day;
BYTE hourbar;
BYTE qhr;
// In Main.c
//RAM array that holds data log values
extern SENSORLOG_RECORD volatile DataLogDayArray[7][24][4]; 

I2Cport = 1;			//24LC512's are on I2C port 1
OpenI2C1( I2C_EN, BRG_VAL );	//open I2C channel 1 EEPROMs

SlaveAddress = 0x50 + 0x01;	//7-bit Serial EEPROM address, of first device, 
HighAddress = 0x00;		//starting addr hi
LowAddress = 0x00;		//starting addr Lo

	Data_1_Memory_io = 0;			//set output to 0=Low for write enable

		for(day =0; day <= 6; day = day + 1)
			{
			for (hourbar = 0; hourbar <= 23; hourbar = hourbar +1)
				{
					for(qhr =0; qhr <= 3; qhr = qhr + 1)	//need to add the four readings in the case of bee traffic each hour for total
					{	
//						Data = DataLogDayArray[day][hourbar][qhr].cTSysController;
	
						Data = ((DataLogDayArray[day][hourbar][qhr].cTSysController) & (0xFF00)) >> 8;		//get the high byte
						Eeprom_Write(I2Cport, SlaveAddress, HighAddress, LowAddress, Data);	//write the hi byte

						LowAddress ++;														//inc low byte addr
						if (LowAddress ==0)													//inc high if low rolled over
							HighAddress++;

						Data = ((DataLogDayArray[day][hourbar][qhr].cTSysController) & (0x00FF));		//get the Lo byte
						Eeprom_Write(I2Cport, SlaveAddress, HighAddress, LowAddress, Data);	//write the lo byte

						LowAddress ++;														//inc low byte addr
						if (LowAddress ==0)													//inc high if low rolled over
						HighAddress++;
//=
						Data = DataLogDayArray[day][hourbar][qhr].cTBaseOutSide;
	
						Data = ((DataLogDayArray[day][hourbar][qhr].cTBaseOutSide) & (0xFF00)) >> 8;		//get the high byte
						Eeprom_Write(I2Cport, SlaveAddress, HighAddress, LowAddress, Data);	//write the hi byte

						LowAddress ++;														//inc low byte addr
						if (LowAddress ==0)													//inc high if low rolled over
							HighAddress++;

						Data = ((DataLogDayArray[day][hourbar][qhr].cTBaseOutSide) & (0x00FF));		//get the Lo byte
						Eeprom_Write(I2Cport, SlaveAddress, HighAddress, LowAddress, Data);	//write the lo byte

						LowAddress ++;														//inc low byte addr
						if (LowAddress ==0)													//inc high if low rolled over
						HighAddress++;
//=
						Data = DataLogDayArray[day][hourbar][qhr].cTBaseInside;
	
						Data = ((DataLogDayArray[day][hourbar][qhr].cTBaseInside) & (0xFF00)) >> 8;		//get the high byte
						Eeprom_Write(I2Cport, SlaveAddress, HighAddress, LowAddress, Data);	//write the hi byte

						LowAddress ++;														//inc low byte addr
						if (LowAddress ==0)													//inc high if low rolled over
							HighAddress++;

						Data = ((DataLogDayArray[day][hourbar][qhr].cTBaseInside) & (0x00FF));		//get the Lo byte
						Eeprom_Write(I2Cport, SlaveAddress, HighAddress, LowAddress, Data);	//write the lo byte

						LowAddress ++;														//inc low byte addr
						if (LowAddress ==0)													//inc high if low rolled over
						HighAddress++;
//=
						Data = DataLogDayArray[day][hourbar][qhr].cTTopOutside;
	
						Data = ((DataLogDayArray[day][hourbar][qhr].cTTopOutside) & (0xFF00)) >> 8;		//get the high byte
						Eeprom_Write(I2Cport, SlaveAddress, HighAddress, LowAddress, Data);	//write the hi byte

						LowAddress ++;														//inc low byte addr
						if (LowAddress ==0)													//inc high if low rolled over
							HighAddress++;

						Data = ((DataLogDayArray[day][hourbar][qhr].cTTopOutside) & (0x00FF));		//get the Lo byte
						Eeprom_Write(I2Cport, SlaveAddress, HighAddress, LowAddress, Data);	//write the lo byte

						LowAddress ++;														//inc low byte addr
						if (LowAddress ==0)													//inc high if low rolled over
						HighAddress++;
//=
						Data = DataLogDayArray[day][hourbar][qhr].cTTopInside;
	
						Data = ((DataLogDayArray[day][hourbar][qhr].cTTopInside) & (0xFF00)) >> 8;		//get the high byte
						Eeprom_Write(I2Cport, SlaveAddress, HighAddress, LowAddress, Data);	//write the hi byte

						LowAddress ++;														//inc low byte addr
						if (LowAddress ==0)													//inc high if low rolled over
							HighAddress++;

						Data = ((DataLogDayArray[day][hourbar][qhr].cTTopInside) & (0x00FF));		//get the Lo byte
						Eeprom_Write(I2Cport, SlaveAddress, HighAddress, LowAddress, Data);	//write the lo byte

						LowAddress ++;														//inc low byte addr
						if (LowAddress ==0)													//inc high if low rolled over
						HighAddress++;
//=
						Data = DataLogDayArray[day][hourbar][qhr].cHumidity;
	
						Data = ((DataLogDayArray[day][hourbar][qhr].cHumidity) & (0xFF00)) >> 8;		//get the high byte
						Eeprom_Write(I2Cport, SlaveAddress, HighAddress, LowAddress, Data);	//write the hi byte

						LowAddress ++;														//inc low byte addr
						if (LowAddress ==0)													//inc high if low rolled over
							HighAddress++;

						Data = ((DataLogDayArray[day][hourbar][qhr].cHumidity) & (0x00FF));		//get the Lo byte
						Eeprom_Write(I2Cport, SlaveAddress, HighAddress, LowAddress, Data);	//write the lo byte

						LowAddress ++;														//inc low byte addr
						if (LowAddress ==0)													//inc high if low rolled over
						HighAddress++;
//=
						Data = DataLogDayArray[day][hourbar][qhr].cDayLight;
	
						Data = ((DataLogDayArray[day][hourbar][qhr].cDayLight) & (0xFF00)) >> 8;		//get the high byte
						Eeprom_Write(I2Cport, SlaveAddress, HighAddress, LowAddress, Data);	//write the hi byte

						LowAddress ++;														//inc low byte addr
						if (LowAddress ==0)													//inc high if low rolled over
							HighAddress++;

						Data = ((DataLogDayArray[day][hourbar][qhr].cDayLight) & (0x00FF));		//get the Lo byte
						Eeprom_Write(I2Cport, SlaveAddress, HighAddress, LowAddress, Data);	//write the lo byte

						LowAddress ++;														//inc low byte addr
						if (LowAddress ==0)													//inc high if low rolled over
						HighAddress++;
//=
						Data = DataLogDayArray[day][hourbar][qhr].cBeeTrafficOut;
	
						Data = ((DataLogDayArray[day][hourbar][qhr].cBeeTrafficOut) & (0xFF00)) >> 8;		//get the high byte
						Eeprom_Write(I2Cport, SlaveAddress, HighAddress, LowAddress, Data);	//write the hi byte

						LowAddress ++;														//inc low byte addr
						if (LowAddress ==0)													//inc high if low rolled over
							HighAddress++;

						Data = ((DataLogDayArray[day][hourbar][qhr].cBeeTrafficOut) & (0x00FF));		//get the Lo byte
						Eeprom_Write(I2Cport, SlaveAddress, HighAddress, LowAddress, Data);	//write the lo byte

						LowAddress ++;														//inc low byte addr
						if (LowAddress ==0)													//inc high if low rolled over
						HighAddress++;
//=
						Data = DataLogDayArray[day][hourbar][qhr].cBeeTrafficIn;
	
						Data = ((DataLogDayArray[day][hourbar][qhr].cBeeTrafficIn) & (0xFF00)) >> 8;		//get the high byte
						Eeprom_Write(I2Cport, SlaveAddress, HighAddress, LowAddress, Data);	//write the hi byte

						LowAddress ++;														//inc low byte addr
						if (LowAddress ==0)													//inc high if low rolled over
							HighAddress++;

						Data = ((DataLogDayArray[day][hourbar][qhr].cBeeTrafficIn) & (0x00FF));		//get the Lo byte
						Eeprom_Write(I2Cport, SlaveAddress, HighAddress, LowAddress, Data);	//write the lo byte

						LowAddress ++;														//inc low byte addr
						if (LowAddress ==0)													//inc high if low rolled over
						HighAddress++;
//=


					}//END qhr
				}//END hourbar
			}//END day
}


//==============================================================================================================


//=====================================================================

void dEEPROM_to_dRAM_Copy(void)
{
unsigned char I2Cport;
unsigned char SlaveAddress;
unsigned char HighAddress;
unsigned char LowAddress;
unsigned char Data;
unsigned char StatusByte;
unsigned char Func_Num;

BYTE day;
BYTE hourbar;
BYTE qhr;

// In Main.c
//RAM array that holds current sensor and function status and values
//	extern FUNCTION_RECORD FunctionModule[FunctionModuleSize];		//since index 0 is skipped,
										// make sure there is enough memory +1 from above #defines

extern SENSORLOG_RECORD volatile DataLogDayArray[7][24][4]; 

I2Cport = 1;			//24LC512's are on I2C port 1
OpenI2C1( I2C_EN, BRG_VAL );	//open I2C channel 1 EEPROMs

SlaveAddress = 0x50 + 0x01;	//7-bit Serial EEPROM address, of first device, A2,A1,A0 is CS, use 001 for this device
HighAddress = 0x00;		//starting addr hi
LowAddress = 0x00;		//starting addr Lo

Data = 0;

	Data_1_Memory_io = 1;			//make sur output is 1=high for WP=protected
		for(day =0; day <= 6; day = day + 1)
			{
			for (hourbar = 0; hourbar <= 23; hourbar = hourbar +1)
				{
					for(qhr =0; qhr <= 3; qhr = qhr + 1)	//need to add the four readings in the case of bee traffic each hour for total
					{
	Data = Eeprom_Read(I2Cport, SlaveAddress, HighAddress, LowAddress);			//Read the Lowerlimit high byte first
	DataLogDayArray[day][hourbar][qhr].cTSysController = Data <<8;

	LowAddress ++;														//inc low byte addr
	if (LowAddress ==0)													//inc high if low rolled over
			HighAddress++;
	DataLogDayArray[day][hourbar][qhr].cTSysController =(DataLogDayArray[day][hourbar][qhr].cTSysController) | Eeprom_Read(I2Cport, SlaveAddress, HighAddress, LowAddress);			//get the Lo byte next

	LowAddress ++;														//inc low byte addr
	if (LowAddress ==0)													//inc high if low rolled over
		HighAddress++;
//=
	Data = Eeprom_Read(I2Cport, SlaveAddress, HighAddress, LowAddress);			//Read the Lowerlimit high byte first
	DataLogDayArray[day][hourbar][qhr].cTBaseOutSide = Data <<8;

	LowAddress ++;														//inc low byte addr
	if (LowAddress ==0)													//inc high if low rolled over
			HighAddress++;
	DataLogDayArray[day][hourbar][qhr].cTBaseOutSide =(DataLogDayArray[day][hourbar][qhr].cTBaseOutSide) | Eeprom_Read(I2Cport, SlaveAddress, HighAddress, LowAddress);			//get the Lo byte next

	LowAddress ++;														//inc low byte addr
	if (LowAddress ==0)													//inc high if low rolled over
		HighAddress++;
//=
	Data = Eeprom_Read(I2Cport, SlaveAddress, HighAddress, LowAddress);			//Read the Lowerlimit high byte first
	DataLogDayArray[day][hourbar][qhr].cTBaseInside = Data <<8;

	LowAddress ++;														//inc low byte addr
	if (LowAddress ==0)													//inc high if low rolled over
			HighAddress++;
	DataLogDayArray[day][hourbar][qhr].cTBaseInside =(DataLogDayArray[day][hourbar][qhr].cTBaseInside) | Eeprom_Read(I2Cport, SlaveAddress, HighAddress, LowAddress);			//get the Lo byte next

	LowAddress ++;														//inc low byte addr
	if (LowAddress ==0)													//inc high if low rolled over
		HighAddress++;
//=
	Data = Eeprom_Read(I2Cport, SlaveAddress, HighAddress, LowAddress);			//Read the Lowerlimit high byte first
	DataLogDayArray[day][hourbar][qhr].cTTopOutside = Data <<8;

	LowAddress ++;														//inc low byte addr
	if (LowAddress ==0)													//inc high if low rolled over
			HighAddress++;
	DataLogDayArray[day][hourbar][qhr].cTTopOutside =(DataLogDayArray[day][hourbar][qhr].cTTopOutside) | Eeprom_Read(I2Cport, SlaveAddress, HighAddress, LowAddress);			//get the Lo byte next

	LowAddress ++;														//inc low byte addr
	if (LowAddress ==0)													//inc high if low rolled over
		HighAddress++;
//=
	Data = Eeprom_Read(I2Cport, SlaveAddress, HighAddress, LowAddress);			//Read the Lowerlimit high byte first
	DataLogDayArray[day][hourbar][qhr].cTTopInside = Data <<8;

	LowAddress ++;														//inc low byte addr
	if (LowAddress ==0)													//inc high if low rolled over
			HighAddress++;
	DataLogDayArray[day][hourbar][qhr].cTTopInside =(DataLogDayArray[day][hourbar][qhr].cTTopInside) | Eeprom_Read(I2Cport, SlaveAddress, HighAddress, LowAddress);			//get the Lo byte next

	LowAddress ++;														//inc low byte addr
	if (LowAddress ==0)													//inc high if low rolled over
		HighAddress++;
//=
	Data = Eeprom_Read(I2Cport, SlaveAddress, HighAddress, LowAddress);			//Read the Lowerlimit high byte first
	DataLogDayArray[day][hourbar][qhr].cHumidity = Data <<8;

	LowAddress ++;														//inc low byte addr
	if (LowAddress ==0)													//inc high if low rolled over
			HighAddress++;
	DataLogDayArray[day][hourbar][qhr].cHumidity =(DataLogDayArray[day][hourbar][qhr].cHumidity) | Eeprom_Read(I2Cport, SlaveAddress, HighAddress, LowAddress);			//get the Lo byte next

	LowAddress ++;														//inc low byte addr
	if (LowAddress ==0)													//inc high if low rolled over
		HighAddress++;
//=
	Data = Eeprom_Read(I2Cport, SlaveAddress, HighAddress, LowAddress);			//Read the Lowerlimit high byte first
	DataLogDayArray[day][hourbar][qhr].cDayLight = Data <<8;

	LowAddress ++;														//inc low byte addr
	if (LowAddress ==0)													//inc high if low rolled over
			HighAddress++;
	DataLogDayArray[day][hourbar][qhr].cDayLight =(DataLogDayArray[day][hourbar][qhr].cDayLight) | Eeprom_Read(I2Cport, SlaveAddress, HighAddress, LowAddress);			//get the Lo byte next

	LowAddress ++;														//inc low byte addr
	if (LowAddress ==0)													//inc high if low rolled over
		HighAddress++;
//=
	Data = Eeprom_Read(I2Cport, SlaveAddress, HighAddress, LowAddress);			//Read the Lowerlimit high byte first
	DataLogDayArray[day][hourbar][qhr].cBeeTrafficOut = Data <<8;

	LowAddress ++;														//inc low byte addr
	if (LowAddress ==0)													//inc high if low rolled over
			HighAddress++;
	DataLogDayArray[day][hourbar][qhr].cBeeTrafficOut =(DataLogDayArray[day][hourbar][qhr].cBeeTrafficOut) | Eeprom_Read(I2Cport, SlaveAddress, HighAddress, LowAddress);			//get the Lo byte next

	LowAddress ++;														//inc low byte addr
	if (LowAddress ==0)													//inc high if low rolled over
		HighAddress++;
//=
	Data = Eeprom_Read(I2Cport, SlaveAddress, HighAddress, LowAddress);			//Read the Lowerlimit high byte first
	DataLogDayArray[day][hourbar][qhr].cBeeTrafficIn = Data <<8;

	LowAddress ++;														//inc low byte addr
	if (LowAddress ==0)													//inc high if low rolled over
			HighAddress++;
	DataLogDayArray[day][hourbar][qhr].cBeeTrafficIn =(DataLogDayArray[day][hourbar][qhr].cBeeTrafficIn) | Eeprom_Read(I2Cport, SlaveAddress, HighAddress, LowAddress);			//get the Lo byte next

//=
			LowAddress ++;														//inc low byte addr
			if (LowAddress ==0)													//inc high if low rolled over
			HighAddress++;

					}//END qhr
				}//END hourbar
			}//END day

Data_1_Memory_io = 1;			//set output to 1=high for WP=protected
}

