//=========================================================
//	InitDataLogInterval.c
//	included in MainDemo.c
//=========================================================

// set datalog flags to occur 4 times per hour
//  Starting on the hour and every 15 minutes
//	DFlags are cleared ar the end of the scan
//	The RTCC is used for this time function, the minutes register is read and compared for time required

LogCompleted = TRUE;		//flag used to determine if a datalogging event just occured
DFlag00 = FALSE;			//flag to indicate a datalog event for time '0' is now due
DFlag15 = FALSE;			//flag to indicate a datalog event for time '15' is now due 
DFlag30 = FALSE;			//flag to indicate a datalog event for time '30' is now due 
DFlag45 = FALSE;			//flag to indicate a datalog event for time '45' is now due 
//the flags are cleared in five minutes from being set, therefore there is a 5 minute 'window' in which to do datalogging

AlarmWaitTimeFlagClears();			//Clear all the "alarm wait time flags"

// set initial defaults to 60 seconds, can be set again later
AlarmWaitTime[Elidopen]= 60;		//Lid Open
AlarmWaitTime[Etiltdetect]= 60;		//Tilt sensor
AlarmWaitTime[EPIR1ms]= 60;			//PIR 1 wait time flag
AlarmWaitTime[EPIR2ms]= 60;			//PIR 2 wait time flag
AlarmWaitTime[EPIR3ms]= 60;			//PIR 3 wait time flag
AlarmWaitTime[EPIR4ms]= 60;			//PIR 4 wait time flag
AlarmWaitTime[E12vmon]= 60;			//+12 volt supply monitor
AlarmWaitTime[E5vmon]= 60;			//+5 volt supply monitor
AlarmWaitTime[E3p3vmonP32]= 60;		//+3 volt P32_VDD supply monitor
AlarmWaitTime[E3p3vmonIO]= 60;		//+3 volt IO_PWR supply monitor
AlarmWaitTime[E3p3vmonFRAME]= 60;	//+3 volt FRAME_PWR supply monitor
AlarmWaitTime[EsysconTEMP]= 60;		//Temperature system controller


