//=========================================================
//	InitializeBarGraphArray.c
// 	this routine setsup the BarGraph storage array for display 
//	
//=========================================================

void MaxBarGraphValues(BYTE gFunc)		//find the max value for this function over the 7 days
{
extern SENSORLOG_RECORD volatile DataLogDayArray[7][24][4];
extern WORD BarGraphMaxHeight [NumberGraphs];
//for each graph function scan the datalog memory for max value to scale it 0-100 for graphing
DWORD Dtemp1, Dtemp2, Dtemp3, D4 =4;
WORD MaxValue;
WORD CurrentValue;
BYTE day;
BYTE hourbar;
BYTE qhr;
WORD temp;
//for each graph function scan(for the 7 days) the datalog memory for max value to scale it 0-100 for graphing
MaxValue = 0;
CurrentValue = 0;
		for(day =0; day <= 6; day = day + 1)
			{
			for (hourbar = 0; hourbar <= 23; hourbar = hourbar +1)
				{	
					if ((gFunc == gBeeTrafficOut) | (gFunc == gBeeTrafficIn))
					{
						CurrentValue = 0;
						for(qhr =0; qhr <= 3; qhr = qhr + 1)	//need to add the four readings in the case of bee traffic each hour for total
						{
							if (gFunc == gBeeTrafficOut)
							{
							temp = DataLogDayArray[day][hourbar][qhr].cBeeTrafficOut;//Add up the 4 readings for the hour
							CurrentValue = CurrentValue + temp;
							}
							if (gFunc == gBeeTrafficIn)
							{
							temp = DataLogDayArray[day][hourbar][qhr].cBeeTrafficIn;//Add up the 4 readings for the hour
							CurrentValue = CurrentValue + temp;
							}
						}

						if(CurrentValue > MaxValue) MaxValue = CurrentValue;
					}//END gFunc

					if ((gFunc == gDayLight) | (gFunc == gHumidity))
					{
						CurrentValue = 0;
						for(qhr =0; qhr <= 3; qhr = qhr + 1)	//need to check each 1/4 hour for max or min value
						{
							if (gFunc == gDayLight)
							CurrentValue = DataLogDayArray[day][hourbar][qhr].cDayLight;
							if (gFunc == gHumidity)
							CurrentValue = DataLogDayArray[day][hourbar][qhr].cHumidity;
						}
						if(CurrentValue > MaxValue) MaxValue = CurrentValue;
					}//END gFunc

					if ((gFunc == gTSysController) | (gFunc == gTBaseOutSide) |(gFunc == gTBaseInside) |
						  (gFunc == gTTopOutside) | (gFunc == gTTopInside))
					{
						Dtemp1 = 0;
						for(qhr =0; qhr <= 3; qhr = qhr + 1)	//need to average the four readings 
						{
							if (gFunc == gTSysController)
							{
							Dtemp1 = Dtemp1 + (DWORD) DataLogDayArray[day][hourbar][qhr].cTSysController;//Add up the 4 readings for the hour  
							}
							if (gFunc == gTBaseOutSide)
							{
							Dtemp1 = Dtemp1 + (DWORD) DataLogDayArray[day][hourbar][qhr].cTBaseOutSide;//Add up the 4 readings for the hour
							}
							if (gFunc == gTBaseInside)
							{
							Dtemp1 = Dtemp1 + (DWORD) DataLogDayArray[day][hourbar][qhr].cTBaseInside;//Add up the 4 readings for the hour
							}
							if (gFunc == gTTopOutside)
							{
							Dtemp1 = Dtemp1 + (DWORD) DataLogDayArray[day][hourbar][qhr].cTTopOutside;//Add up the 4 readings for the hour
							}
							if (gFunc == gTTopInside)
							{
							Dtemp1 = Dtemp1 + (DWORD) DataLogDayArray[day][hourbar][qhr].cTTopInside;//Add up the 4 readings for the hour
							}
						}
						Dtemp2 = Dtemp1/D4;						//divide by 4 to get average
						CurrentValue = (WORD) Dtemp2;			//convert back to WORD
						if(CurrentValue > MaxValue) MaxValue = CurrentValue;
					}//END gFunc

				}//END hourbar
			}//END day
	
		BarGraphMaxHeight[gFunc] = MaxValue;		//save the max value for over the 7 days
}

void ScaleRawData(BYTE gFunc)		//scales the raw data and puts it into the graphing array BarGraphHeight
{
extern SENSORLOG_RECORD volatile DataLogDayArray[7][24][4];
extern WORD BarGraphMaxHeight[NumberGraphs];
DWORD Dtemp1, Dtemp2, Dtemp3, D100 = 100; 
WORD MaxValue;
WORD CurrentValue;
BYTE day;
BYTE hourbar;
BYTE qhr;
WORD temp;
// Height of Bar = (Datalog Value * 100)/ MaxValue    for 0-100% of scale
	MaxBarGraphValues(gFunc);		//update max value for scaling

	Nop();
		for(day =0; day <= 6; day = day + 1)
			{
			for (hourbar = 0; hourbar <= 23; hourbar = hourbar +1)
				{
					if ((gFunc == gBeeTrafficOut) | (gFunc == gBeeTrafficIn))
					{
						CurrentValue = 0;
						for(qhr =0; qhr <= 3; qhr = qhr + 1)	//need to add the four readings in the case of bee traffic each hour for total
						{	
							if (gFunc == gBeeTrafficOut)
								{
								temp = DataLogDayArray[day][hourbar][qhr].cBeeTrafficOut;//Add up the 4 readings for the hour
								CurrentValue = CurrentValue + temp; 
								}
							if (gFunc == gBeeTrafficIn)
								{
								temp = DataLogDayArray[day][hourbar][qhr].cBeeTrafficIn;//Add up the 4 readings for the hour
								CurrentValue = CurrentValue + temp; 
								}
						}
					}

					if ((gFunc == gDayLight) | (gFunc == gHumidity))
					{
						CurrentValue = 0;
						for(qhr =0; qhr <= 3; qhr = qhr + 1)	//look for the max value in all 4 readings
						{
							if (gFunc == gDayLight)
								{
								CurrentValue = DataLogDayArray[day][hourbar][qhr].cDayLight;
								}
							if (gFunc == gHumidity)
								{
								CurrentValue = DataLogDayArray[day][hourbar][qhr].cHumidity;
								}
						}
					}

					if ((gFunc == gTSysController) | (gFunc == gTBaseOutSide) |(gFunc == gTBaseInside) |
						  (gFunc == gTTopOutside) | (gFunc == gTTopInside))
					{
						CurrentValue = 0;
						for(qhr =0; qhr <= 3; qhr = qhr + 1)	//look for the max value in all 4 readings
						{
							if (gFunc == gTSysController)
								{
								CurrentValue = DataLogDayArray[day][hourbar][qhr].cTSysController;
								Nop();
								}
							if (gFunc == gTBaseOutSide)
								{
								CurrentValue = DataLogDayArray[day][hourbar][qhr].cTBaseOutSide;
								Nop();
								}
							if (gFunc == gTBaseInside)
								{
								CurrentValue = DataLogDayArray[day][hourbar][qhr].cTBaseInside;
								Nop();
								}
							if (gFunc == gTTopOutside)
								{
								CurrentValue = DataLogDayArray[day][hourbar][qhr].cTTopOutside;
								Nop();
								}
							if (gFunc == gTTopInside)
								{
								CurrentValue = DataLogDayArray[day][hourbar][qhr].cTTopInside;
								Nop();
								}
						}
					}


//CurrentValue * 100)/BarGraphMaxHeight[gFunc]
//					temp = BarGraphMaxHeight[gFunc]; 
//					BarGraphHeight[gFunc][day][hourbar] = (CurrentValue * 100)/temp;
				Dtemp1 = (DWORD) BarGraphMaxHeight[gFunc];
				Dtemp2 = (DWORD) CurrentValue;
				Dtemp3 = ((Dtemp2 * D100) / Dtemp1);
				BarGraphHeight[gFunc][day][hourbar] = (WORD)Dtemp3;
				Nop();
				}//END hourbar
			}//END day
	}
//}

//===============================================================
//RAM array that holds the height of each bar for the graphs
//BYTE BarGraph[BYTE ChartName, BYTE GraphDay, BYTE BarPosition];
//===============================================================
void InitializeBarGraphArray(void)
{
extern SENSORLOG_RECORD volatile DataLogDayArray[7][24][4]; // Hourly reading every 15min (1/4hr) for 7 days running then over writes data continously
extern BOOL TestModeBMS;
BYTE day, LogDay,DayHour, Reading;
BYTE bar;
BYTE cFuncData;
WORD gData;

//Clear all datalog memory first
for (cFuncData = 0; cFuncData <= NumberGraphs; cFuncData = cFuncData +1);
{
	for(day =0; day <= 6; day = day + 1)
	{
		for (bar = 0; bar <= 23; bar = bar +1)
		{
			BarGraphHeight[cFuncData][day][bar] = 0;
		}//END bar
	}//END day
}//END cFuncData


if (TestModeBMS == TRUE)
{
	for(LogDay =0; LogDay <= 6; LogDay = LogDay + 1)
	{
		for (Reading = 0; Reading <= 3; Reading = Reading +1)
		{
			for (DayHour = 0; DayHour <= 12; DayHour = DayHour +1)
			{
			gData = DayHour* 8;
			DataLogDayArray[LogDay][DayHour][Reading].cHumidity =  gData;
			DataLogDayArray[LogDay][DayHour][Reading].cDayLight =  gData;
			DataLogDayArray[LogDay][DayHour][Reading].cBeeTrafficIn =  gData;
			DataLogDayArray[LogDay][DayHour][Reading].cBeeTrafficOut =  gData;

			DataLogDayArray[LogDay][DayHour][Reading].cTSysController =  gData;
			DataLogDayArray[LogDay][DayHour][Reading].cTBaseOutSide =  gData;
			DataLogDayArray[LogDay][DayHour][Reading].cTBaseInside =  gData;
			DataLogDayArray[LogDay][DayHour][Reading].cTTopOutside =  gData;
			DataLogDayArray[LogDay][DayHour][Reading].cTTopInside =  gData;

			}

			for (DayHour = 13; DayHour <= 23; DayHour = DayHour + 1)
			{
			gData = (24 - DayHour) * 8;
			DataLogDayArray[LogDay][DayHour][Reading].cHumidity =  gData;
			DataLogDayArray[LogDay][DayHour][Reading].cDayLight =  gData;
			DataLogDayArray[LogDay][DayHour][Reading].cBeeTrafficIn =  gData;
			DataLogDayArray[LogDay][DayHour][Reading].cBeeTrafficOut =  gData;

			DataLogDayArray[LogDay][DayHour][Reading].cTSysController =  gData;
			DataLogDayArray[LogDay][DayHour][Reading].cTBaseOutSide =  gData;
			DataLogDayArray[LogDay][DayHour][Reading].cTBaseInside =  gData;
			DataLogDayArray[LogDay][DayHour][Reading].cTTopOutside =  gData;
			DataLogDayArray[LogDay][DayHour][Reading].cTTopInside =  gData;
			}
		}
	}

}//END TestModeBMS==TRUE

}//END InitializeBarGraphArray();
//=======================

