
//##################################################################################################################
//==================================================================================================================
//
//	This work of art is brought to you by the Microchip PIC32 Design Contest and Carl the beekeeper.
//
//	I started with the Microchip  PIC32 starter kit, expansion board, Ethernet module AC164123, TCPIP Demo App, and
//	went from there.  By the way, while I had done a lot of programming in past years I have NOT used 'C' for about 
//	the last 15 years, although I have used PASCAL a lot about 5-15 years ago and Visual Basic Studio most recently.
//	So I know there is room for code improvement.  Since I was learning the PIC32 architecture along the way, I'm sure 
//	you will find some things that look goofy, but remember, IT WORKS! Also, because I was debugging hardware, software 
//	and new libraries along the way, there is extra code things like Nop's that make no sense at all why they are 
//	there or variables that just copy from one to another without being used (this was mostly done because the 'watch'
//	window doesn't seem to display multi dimensional arrays as the program got big.  I will likely remove all of this
//	clutter before the final release, along with cleaning up some of the actual code.  I have not changed any of the
//	documentation headers at the tops of files.  So even though I may modified and added code, you can find the 
//	original source of it if needed.  All code used or developed in this project is intended to be used only with 
//	Microchip processors.  
//	This is the first web server project I have ever undertaken.  Also, for what it is worth I hadn't ever written
//	any HTML code before.  So I also had to learn that from scratch basically.  I had a lot of fun and learned a lot 
//	along the way.  I have so many more ideas I want to incorporate into this design yet.  I hope you find some useful
//	ideas in this project that can be used for your own work of art.
//
//								Proceed at your own risk from here.  
//	
//==================================================================================================================
//##################################################################################################################


/*********************************************************************
 *
 *  Main Application Entry Point and TCP/IP Stack Demo
 *  Module for Microchip TCP/IP Stack
 *   -Demonstrates how to call and use the Microchip TCP/IP stack
 *	 -Reference: AN833
 *
 *********************************************************************
 * FileName:        MainDemo.c
 * Dependencies:    TCPIP.h
 * Processor:       PIC18, PIC24F, PIC24H, dsPIC30F, dsPIC33F, PIC32
 * Compiler:        Microchip C32 v1.00 or higher
 *					Microchip C30 v3.01 or higher
 *					Microchip C18 v3.13 or higher
 *					HI-TECH PICC-18 STD 9.50PL3 or higher
 * Company:         Microchip Technology, Inc.
 *
 * Software License Agreement
 *
 * Copyright (C) 2002-2008 Microchip Technology Inc.  All rights 
 * reserved.
 *
 * Microchip licenses to you the right to use, modify, copy, and 
 * distribute: 
 * (i)  the Software when embedded on a Microchip microcontroller or 
 *      digital signal controller product ("Device") which is 
 *      integrated into Licensee's product; or
 * (ii) ONLY the Software driver source files ENC28J60.c and 
 *      ENC28J60.h ported to a non-Microchip device used in 
 *      conjunction with a Microchip ethernet controller for the 
 *      sole purpose of interfacing with the ethernet controller. 
 *
 * You should refer to the license agreement accompanying this 
 * Software for additional information regarding your rights and 
 * obligations.
 *
 * THE SOFTWARE AND DOCUMENTATION ARE PROVIDED "AS IS" WITHOUT 
 * WARRANTY OF ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT 
 * LIMITATION, ANY WARRANTY OF MERCHANTABILITY, FITNESS FOR A 
 * PARTICULAR PURPOSE, TITLE AND NON-INFRINGEMENT. IN NO EVENT SHALL 
 * MICROCHIP BE LIABLE FOR ANY INCIDENTAL, SPECIAL, INDIRECT OR 
 * CONSEQUENTIAL DAMAGES, LOST PROFITS OR LOST DATA, COST OF 
 * PROCUREMENT OF SUBSTITUTE GOODS, TECHNOLOGY OR SERVICES, ANY CLAIMS 
 * BY THIRD PARTIES (INCLUDING BUT NOT LIMITED TO ANY DEFENSE 
 * THEREOF), ANY CLAIMS FOR INDEMNITY OR CONTRIBUTION, OR OTHER 
 * SIMILAR COSTS, WHETHER ASSERTED ON THE BASIS OF CONTRACT, TORT 
 * (INCLUDING NEGLIGENCE), BREACH OF WARRANTY, OR OTHERWISE.
 *
 *
 * Author              Date         Comment
 *~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 * Nilesh Rajbharti		4/19/01		Original (Rev. 1.0)
 * Nilesh Rajbharti		2/09/02		Cleanup
 * Nilesh Rajbharti		5/22/02		Rev 2.0 (See version.log for detail)
 * Nilesh Rajbharti		7/9/02		Rev 2.1 (See version.log for detail)
 * Nilesh Rajbharti		4/7/03		Rev 2.11.01 (See version log for detail)
 * Howard Schlunder		10/1/04		Beta Rev 0.9 (See version log for detail)
 * Howard Schlunder		10/8/04		Beta Rev 0.9.1 Announce support added
 * Howard Schlunder		11/29/04	Beta Rev 0.9.2 (See version log for detail)
 * Howard Schlunder		2/10/05		Rev 2.5.0
 * Howard Schlunder		1/5/06		Rev 3.00
 * Howard Schlunder		1/18/06		Rev 3.01 ENC28J60 fixes to TCP, 
 *									UDP and ENC28J60 files
 * Howard Schlunder		3/01/06		Rev. 3.16 including 16-bit micro support
 * Howard Schlunder		4/12/06		Rev. 3.50 added LCD for Explorer 16
 * Howard Schlunder		6/19/06		Rev. 3.60 finished dsPIC30F support, added PICDEM.net 2 support
 * Howard Schlunder		8/02/06		Rev. 3.75 added beta DNS, NBNS, and HTTP client (GenericTCPClient.c) services
 * Howard Schlunder		12/28/06	Rev. 4.00RC added SMTP, Telnet, substantially modified TCP layer
 * Howard Schlunder		04/09/07	Rev. 4.02 added TCPPerformanceTest, UDPPerformanceTest, Reboot and fixed some bugs
 * Howard Schlunder		xx/xx/07	Rev. 4.03
 * HSchlunder & EWood	08/27/07	Rev. 4.11
 * HSchlunder & EWood	10/08/07	Rev. 4.13
 * HSchlunder & EWood	11/06/07	Rev. 4.16
 * HSchlunder & EWood	11/08/07	Rev. 4.17
 * HSchlunder & EWood	11/12/07	Rev. 4.18
 * HSchlunder & EWood	02/11/08	Rev. 4.19
 * HSchlunder & EWood   04/26/08    Rev. 4.50 Moved most code to other files for clarity
 * HSchlunder & EWood   07/24/08    Rev. 4.51
 ********************************************************************/

/*
 * This macro uniquely defines this file as the main entry point.
 * There should only be one such definition in the entire project,
 * and this file must define the AppConfig variable as described below.
 */
#define THIS_IS_STACK_APPLICATION

// Include all headers for any enabled TCPIP Stack functions
#include "TCPIP Stack/TCPIP.h"

// Include functions specific to this stack application
#include "MainDemo.h"
#include "BMS_Globals.h"
#include <plib.h>
#include "BMS_DataLog.c"



// Declare AppConfig structure and some other supporting stack variables
APP_CONFIG AppConfig;
BYTE AN0String[8];
BYTE myDHCPBindCount = 0xFF;
#if !defined(STACK_USE_DHCP_CLIENT)
	#define DHCPBindCount	(1)
#endif

// Private helper functions.
// These may or may not be present in all applications.
static void InitAppConfig(void);
static void InitializeBoard(void);
static void ProcessIO(void);

//
// PIC18 Interrupt Service Routines
// 
// NOTE: Several PICs, including the PIC18F4620 revision A3 have a RETFIE FAST/MOVFF bug
// The interruptlow keyword is used to work around the bug when using C18
#if defined(__18CXX)
	#if defined(HI_TECH_C)
	void interrupt low_priority LowISR(void)
	#else
	#pragma interruptlow LowISR
	void LowISR(void)
	#endif
	{
	    TickUpdate();
	}
	
	#if defined(HI_TECH_C)
	void interrupt HighISR(void)
	#else
	#pragma interruptlow HighISR
	void HighISR(void)
	#endif
	{
	    #if defined(STACK_USE_UART2TCP_BRIDGE)
		UART2TCPBridgeISR();
		#endif
	}
	
	#if !defined(HI_TECH_C)
	#pragma code lowVector=0x18
	void LowVector(void){_asm goto LowISR _endasm}
	#pragma code highVector=0x8
	void HighVector(void){_asm goto HighISR _endasm}
	#pragma code // Return to default code section
	#endif

// C30 and C32 Exception Handlers
// If your code gets here, you either tried to read or write
// a NULL pointer, or your application overflowed the stack
// by having too many local variables or parameters declared.
#elif defined(__C30__)
	void _ISR __attribute__((__no_auto_psv__)) _AddressError(void)
	{
	    Nop();
		Nop();
	}
	void _ISR __attribute__((__no_auto_psv__)) _StackError(void)
	{
	    Nop();
		Nop();
	}
	
#elif defined(__C32__)
	void _general_exception_handler(unsigned cause, unsigned status)
	{
		Nop();
		Nop();
	}
#endif



// Global array static volatile
//Alarm wait flags
ALARM_FLAGS_RECORD volatile Repeat_Alarm_HoldOff;		//Wait time flgs for repeat alarm condition
DWORD	AlarmWaitTime[24];		//for alarm condition repeat wait, when alarm first occurs the repeatwait time is saved here
// and is decremented each second 

//RAM array that holds current sensor and function status and values
FUNCTION_RECORD volatile FunctionModule[FunctionModuleSize];		//since index 0 is skipped,
										// make sure there is enough memory +1 from above #defines

//RAM array holding one hour of data for each sensor function for 7 days, reading is stored every 15 min for 1 hour 
//then average value (or total as for bee traffic count) is witten to EEPROM each hour and this array is reset each hour.
SENSORLOG_RECORD volatile DataLogDayArray[7][24][4]; // Hourly reading every 15min (1/4hr) for 7 days running then over writes data continously

//each hour the above array values are averaged then written into the following array
//SENSORLOG_RECORD volatile DataLogOneDayArray[24]; //average reading per hour
//at the end of the day the above array data is copied into the EEPROM 

//static DWORD DataLog5Tick = 0;				//counter to determine when 5 minutes of ticks (5min=300sec) are up

//RAM array that holds the height of each bar for the graphs
//	BarGraphHeight	[ChartNames]	[GraphDay]	[BarPosition]  
BYTE BarGraphHeight[NumberGraphs][7][24];			//stores graph BarHeight
WORD BarGraphMaxHeight[NumberGraphs];		//looks over the 7 days for the max, use to scale height

static enum				//State machine for processing emailing immediate request for selected days
{
	DATALOG_NOW_HOME = 0,
	DATALOG_NOW_SUN,
	DATALOG_NOW_MON,
	DATALOG_NOW_TUE,
	DATALOG_NOW_WED,
	DATALOG_NOW_THU,
	DATALOG_NOW_FRI,
	DATALOG_NOW_SAT
} DATALOG_NOW_STATE = DATALOG_NOW_HOME;

static enum
{	
	AnalysisStartTimeTopL = 0,
	AnalysisStopTimeTopL,
	AnalysisStartTimeTopR,
	AnalysisStopTimeTopR,
	AnalysisStartTimeBottomL,
	AnalysisStopTimeBottomL,
	AnalysisStartTimeBottomR,
	AnalysisStopTimeBottomR
} TIME_TO_ANALYZE = AnalysisStartTimeTopL;			//selected times to graph

BYTE AnalysisTime[8];				//array that holds selected analysis times

WORD BarGraph1DayL = 0;							//Day selected for bar graph #1 Left
WORD BarGraph2DayL = 1;							//Day selected for bar graph #2 Left
WORD BarGraph1DayR = 0;							//Day selected for bar graph #1 Right
WORD BarGraph2DayR = 1;							//Day selected for bar graph #2 Right
 

BYTE BarLR_Flag;							//last request for bar position left==0 or right=1

//State Machine defs
static enum				//Servo states
{
	SERVO_HOME = 0,		//time for servo to turn
	SERVO_1_POSITION,		//check the position of one servo each pass
	SERVO_2_POSITION,
	SERVO_3_POSITION,
	SERVO_4_POSITION,
	SERVO_5_POSITION,
	SERVO_6_POSITION,
	SERVO_7_POSITION,
	SERVO_8_POSITION,
	SERVO_AGAIN
} SERVOState = SERVO_HOME;

static enum				//General function states
{
	GENERAL_HOME =0,
	ELECT_FENCE,	
	COOLING_MODULE,
	HEATING_MODULE,
	RAIN_MODULE,
	SMOKE_MODULE,
	INTERIOR_LIGHT,
	EXTERIOR_LIGHT,
	AUXDEV_5,
	AUXDEV_6,
	AUXDEV_7,
	AUXDEV_8,
	HIVE_STATUS_RED,
	HIVE_STATUS_YELLOW,
	GENERAL_AGAIN
} GENERALFUNCTIONState = ELECT_FENCE;

static enum				//Security check states
{
	ALARM_HOME =0,
	LID_OPEN_SENSOR,
	TILT_SENSOR,
	PIR1_SENSOR,
	PIR2_SENSOR,
	PIR3_SENSOR,
	PIR4_SENSOR,
	ALARM_AGAIN
} ALARMCHECKState = ALARM_HOME;

static enum				//Diagnostic check states
{
	DIAG_HOME = 0,
	P12VMON_CHECK,
	DIAG_AGAIN
} DIAGCHECKState = DIAG_HOME;

static enum				//Bee Traffic Counter check states
{
	TRAFFIC_HOME = 0,
	TRAFFIC_1_CHECK,
	TRAFFIC_AGAIN
} TRAFFIC_CHECKState = TRAFFIC_HOME;




// set datalog flags to occur 4 times per hour
//  Starting on the hour and every 15 minutes
//	The RTCC is used for this time function, the minutes register is read and compared for time required
BOOL LogCompleted = TRUE;		//flag used to determine if a datalogging event just occured
BOOL DFlag00 = FALSE;			//flag to indicate a datalog event for time '0' is now due
BOOL DFlag15 = FALSE;			//flag to indicate a datalog event for time '15' is now due 
BOOL DFlag30 = FALSE;			//flag to indicate a datalog event for time '30' is now due 
BOOL DFlag45 = FALSE;			//flag to indicate a datalog event for time '45' is now due 
//the flags are cleared in five minutes from being set, therefore there is a 5 minute 'window' in which to do datalogging/

	rtccTime tm;	// time structure	, tm1
	rtccDate dt;	// date structure	, dt1

// RTCC clock starting time at boot
#define dtyear		0x09;				//0-99,	Starting at year 2000
#define dtmon		0x03;				//1-12, Jan = 1
#define dtmday		0x02;				//1-31
#define dtwday		0x01;				//0-6,	Sun = 0
#define tmhour		0x23;				//0-23
#define tmmin		0x59;				//0-59
#define	tmsec		0x00;				//0-59

#include "BMS_AlarmWaitTimeFlagResets.c"

//
//	BMS Global Variables
WORD ADval;		//used for ADC readings
BYTE ResultString[16];
WORD ResultValue;
//	BYTE AnalysisStartTimeTopL;			//Analysis start time for top graph, left bar
//	BYTE AnalysisStopTimeTopL;			//Analysis stop time for top graph, left bar
//	BYTE AnalysisStartTimeTopR;			//Analysis start time for top graph, right bar
//	BYTE AnalysisStopTimeTopR;			//Analysis stop time for top graph, right bar
//	BYTE AnalysisStartTimeBottomL;		//Analysis start time for bottom graph, left bar
//	BYTE AnalysisStopTimeBottomL;		//Analysis stop time for bottom graph, left bar
//	BYTE AnalysisStartTimeBottomR;		//Analysis start time for bottom graph, right bar
//	BYTE AnalysisStopTimeBottomR;		//Analysis stop time for bottom graph, right bar


// Email buffers
volatile BYTE EMtoStr[40] = "status@PICsAreGreat.com";						//email to address
volatile BYTE EMfromStr[40] = "hive1@GreatBeeYard.com";			//email from string
volatile BYTE EMStrBody[80] = "SECURITY-lid open";					//email message
volatile BYTE EMSubject[80] = "SECURITY ALERT- 101";					//suject text
volatile BYTE EMServer[40] = "mail.beelab.com";						//email server
volatile BYTE EmailAlertBusyFlag;		//Indicates if there is an alert email is process
volatile BYTE EmailDLogBusyFlag;		//Indicates if there is an data log email is process
volatile BYTE RequestLogNowFlagsWeb;		//bits set by web page requesting days to email data log info for
volatile BYTE DataLogNowFlag;			//Indicates if there is an immediate request for emailing a data log dump
				// The day of the week to email is selected by the bit set in the BYTE, bits 0-6 = Sun ==> Sat
				// If all bits off then BYTE is FALSE

volatile BYTE SubjectID;			//SubjectID used to set Subject header text for emails
volatile BOOL MoreLogDays = TRUE;			//flag to keep track of where we are at in email process in sending data logs
volatile BYTE ELogDay;				//byte to pass day selected for data log to email
volatile BYTE MidNightLogFlag = FALSE;		//Flag to indicate when we are in or just have completed a midnight email data log event

// Ground AUX4 will set the following TestModeBMS flag on power up.  Normal mode this should be FALSE. Used to simulate test data
BOOL TestModeBMS = FALSE;		//generates data pattern, set this flag only to use special routines to test code, must be FALSE for normal use
//BOOL QuickDataBMS = FALSE;	//Takes sensor readings fast for program test and debug
BYTE tempt;
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// Main application entry point.
//
int main(void)
{
	Data_1_Memory_io = 1;			//set output to 1=high for WP=protected
	Data_1_Memory_tris = 0;			// set I2C1 WP tris pin for output

    static TICK t = 0;
	BeeOutCounter = 0;
	BeeInCounter = 0;

    // Initialize application specific hardware
    InitializeBoard();

	// Warm Start Configuration, RESTORE EEPROM to RAM
	EEPROM_to_RAM_Copy();		//EEPROM to RAM copy
	ConfigureEnabledBeeTrafficCounters();	//Configure the software for enabled traffic counters

	#if defined(USE_LCD)
	// Initialize and display the stack version on the LCD
	LCDInit();
	DelayMs(100);
	strcpypgm2ram((char*)LCDText, "TCPStack " VERSION "  "
		"                ");
	LCDUpdate();
	#endif

	// Initialize stack-related hardware components that may be 
	// required by the UART configuration routines
    TickInit();
	#if defined(STACK_USE_MPFS) || defined(STACK_USE_MPFS2)
	MPFSInit();
	#endif

	// Initialize Stack and application related NV variables into AppConfig.
	InitAppConfig();

    // Initiates board setup process if button is depressed 
	// on startup
    if (BUTTON_SW1_IO == 0u)
    {
		#if (defined(MPFS_USE_EEPROM) || defined(MPFS_USE_SPI_FLASH)) && (defined(STACK_USE_MPFS) || defined(STACK_USE_MPFS2))
		// Invalidate the EEPROM contents if BUTTON0 is held down for more than 4 seconds
		TICK StartTime = TickGet();
	//	LED_PUT(0x00);
				
		while(BUTTON_SW1_IO == 0u)
		{
			if(TickGet() - StartTime > 4*TICK_SECOND)
			{
				#if defined(MPFS_USE_EEPROM)
			    XEEBeginWrite(0x0000);
			    XEEWrite(0xFF);
			    XEEEndWrite();
			    #elif defined(MPFS_USE_SPI_FLASH)
			    SPIFlashBeginWrite(0x00);
			    SPIFlashWrite(0xFF);
			    #endif
			    
				#if defined(STACK_USE_UART)
				putrsUART("\r\n\r\nBUTTON0 held for more than 4 seconds.  Default settings restored.\r\n\r\n");
				#endif

//				LED_PUT(0x0F);
				while((LONG)(TickGet() - StartTime) <= (LONG)(9*TICK_SECOND/2));
	//			LED_PUT(0x00);
				while(BUTTON_SW1_IO == 0u);
				Reset();
				break;
			}
		}
		#endif

		#if defined(STACK_USE_UART)
        DoUARTConfig();
		#endif
    }

	// Initialize core stack layers (MAC, ARP, TCP, UDP) and
	// application modules (HTTP, SNMP, etc.)
    StackInit();

	// Initialize any application-specific modules or functions/
	// For this demo application, this only includes the
	// UART 2 TCP Bridge
	#if defined(STACK_USE_UART2TCP_BRIDGE)
	UART2TCPBridgeInit();
	#endif

	// Now that all items are initialized, begin the co-operative
	// multitasking loop.  This infinite loop will continuously 
	// execute all stack-related tasks, as well as your own
	// application's functions.  Custom functions should be added
	// at the end of this loop.
    // Note that this is a "co-operative mult-tasking" mechanism
    // where every task performs its tasks (whether all in one shot
    // or part of it) and returns so that other tasks can do their
    // job.
    // If a task needs very long time to do its job, it must be broken
    // down into smaller pieces so that other tasks can have CPU time.
    while(1)
    {
//	Bee_Entering_Hive_LEDio ^=1;		//for testing, when uncommented,used to measure loop time with scope

		if (EmailAlertBusyFlag == TRUE)				//if Emailing set Yellow status LED on
			YellowStatusLEDio = 1;
				else
					YellowStatusLEDio = 0;

		if (EmailDLogBusyFlag == TRUE)				//if Emailing set Yellow status LED on
			RedStatusLEDio = 1;
				else
					RedStatusLEDio = 0;


        // Blink GreenStatusLED every second.
        if(TickGet() - t >= TICK_SECOND/2ul)
        {
            t = TickGet();
    
		//check Hive status green LED opto output status
			if ((FunctionModule[EHiveStatGrnLED].Status.Installed) && (FunctionModule[EHiveStatGrnLED].Status.Enabled))
			GreenStatusLEDio ^= 1;   //toggle Green Status LED to show TCP stack is working

		// decrement alarm wait counters
			if (AlarmWaitTime[Elidopen]>0)  
				AlarmWaitTime[Elidopen]--;
					else
						Repeat_Alarm_HoldOff.LidOpenFlag = FALSE;		//Lid Open wait time flag
			if (AlarmWaitTime[Etiltdetect]>0) 
				AlarmWaitTime[Etiltdetect]--;
					else
						Repeat_Alarm_HoldOff.TiltFlag = FALSE;			//Tilt sensor wait time flag
			if (AlarmWaitTime[EPIR1ms]>0) 
				AlarmWaitTime[EPIR1ms]--;
					else
						Repeat_Alarm_HoldOff.PIR1Flag = FALSE;			//PIR 1 wait time flag
			if (AlarmWaitTime[EPIR2ms]>0)  
				AlarmWaitTime[EPIR2ms]--;
					else
						Repeat_Alarm_HoldOff.PIR2Flag = FALSE;			//PIR 2 wait time flag
			if (AlarmWaitTime[EPIR3ms]>0)  
				AlarmWaitTime[EPIR3ms]--;
					else
						Repeat_Alarm_HoldOff.PIR3Flag = FALSE;			//PIR 3 wait time flag
			if (AlarmWaitTime[EPIR4ms]>0)  
				AlarmWaitTime[EPIR4ms]--;
					else
						Repeat_Alarm_HoldOff.PIR4Flag = FALSE;			//PIR 4 wait time flag
			if (AlarmWaitTime[E12vmon]>0) 
				AlarmWaitTime[E12vmon]--;
					else
						Repeat_Alarm_HoldOff.Vm12Flag = FALSE;			//+12 volt supply monitor wait time flag
			if (AlarmWaitTime[E5vmon]>0)
				AlarmWaitTime[E5vmon]--;
					else
						Repeat_Alarm_HoldOff.Vm5Flag = FALSE;			//+5 volt supply monitor wait time flag
			if (AlarmWaitTime[E3p3vmonP32]>0) 
				AlarmWaitTime[E3p3vmonP32]--;
					else
						Repeat_Alarm_HoldOff.Vm3P32Flag = FALSE;		//+3 volt P32_VDD supply monitor wait time flag
			if (AlarmWaitTime[E3p3vmonIO]>0) 
				AlarmWaitTime[E3p3vmonIO]--;
					else
						Repeat_Alarm_HoldOff.Vm3IOFlag = FALSE;			//+3 volt IO_PWR supply monitor wait time flag
			if (AlarmWaitTime[E3p3vmonFRAME]>0)
				AlarmWaitTime[E3p3vmonFRAME]--;
					else
						Repeat_Alarm_HoldOff.Vm3FrameFlag = FALSE;		//+3 volt FRAME_PWR supply monitor wait time flag
			if (AlarmWaitTime[EsysconTEMP]>0)
				AlarmWaitTime[EsysconTEMP]--;
					else
						Repeat_Alarm_HoldOff.TempSysConFlag = FALSE;	//Temperature system controller wait time flag
        }

//	These two buttons are used to similate bee traffic for testing software during development
 if (BUTTON_SW1_IO == 0)
	{
	Bee_Entering_Hive_LEDio ^= 1;
	BeeInCounter++;
	}

if (BUTTON_SW2_IO == 0)
	{
	Bee_Leaving_Hive_LEDio ^=1;
	BeeOutCounter++;
	}

//=========================================================
        // This task performs normal stack task including checking
        // for incoming packet, type of packet and calling
        // appropriate stack entity to process it.
        StackTask();
        
        // This tasks invokes each of the core stack application tasks
        StackApplications();
//======================================================================
		// Process application specific tasks here.
		// For this demo app, this will include the Generic TCP 
		// client and servers, and the SNMP, Ping, and SNMP Trap
		// demos.  Following that, we will process any IO from
		// the inputs on the board itself.
		// Any custom modules or processing you need to do should
		// go here.

#include "BMS_ProcessIO.c"				

//===================================================================================
		#if defined(STACK_USE_GENERIC_TCP_CLIENT_EXAMPLE)		// commented out in TCPIPConfig.h
		GenericTCPClient();
		#endif
		
		#if defined(STACK_USE_GENERIC_TCP_SERVER_EXAMPLE)		// commented out in TCPIPConfig.h
		GenericTCPServer();
		#endif
		
	//	#if defined(STACK_USE_SMTP_CLIENT)					
	//	SMTPDemo();
	//	#endif
		
		#if defined(STACK_USE_ICMP_CLIENT)						// commented out in TCPIPConfig.h
		PingDemo();
		#endif
		
		#if defined(STACK_USE_SNMP_SERVER) && !defined(SNMP_TRAP_DISABLED)
		SNMPTrapDemo();
		#endif
		
//		#if defined(STACK_USE_BERKELEY_API)
//		BerkeleyTCPClientDemo();
//		BerkeleyTCPServerDemo();
//		BerkeleyUDPClientDemo();
//		#endif

		ProcessIO();

        // If the DHCP lease has changed recently, write the new
        // IP address to the LCD display, UART, and Announce service
		if(DHCPBindCount != myDHCPBindCount)
		{
			myDHCPBindCount = DHCPBindCount;

			#if defined(STACK_USE_UART)
				putrsUART((ROM char*)"\r\nNew IP Address: ");
			#endif

			DisplayIPValue(AppConfig.MyIPAddr);

			#if defined(STACK_USE_ANNOUNCE)
				AnnounceIP();
			#endif
		}

	}
}

// Writes an IP address to the LCD display and the UART as available
void DisplayIPValue(IP_ADDR IPVal)
{
//	printf("%u.%u.%u.%u", IPVal.v[0], IPVal.v[1], IPVal.v[2], IPVal.v[3]);
    BYTE IPDigit[4];
	BYTE i;
#ifdef USE_LCD
	BYTE j;
	BYTE LCDPos=16;
#endif

	for(i = 0; i < sizeof(IP_ADDR); i++)
	{
	    uitoa((WORD)IPVal.v[i], IPDigit);

		#if defined(STACK_USE_UART)
			putsUART(IPDigit);
		#endif

		#ifdef USE_LCD
			for(j = 0; j < strlen((char*)IPDigit); j++)
			{
				LCDText[LCDPos++] = IPDigit[j];
			}
			if(i == sizeof(IP_ADDR)-1)
				break;
			LCDText[LCDPos++] = '.';
		#else
			if(i == sizeof(IP_ADDR)-1)
				break;
		#endif

		#if defined(STACK_USE_UART)
			while(BusyUART());
			WriteUART('.');
		#endif
	}

	#ifdef USE_LCD
		if(LCDPos < 32u)
			LCDText[LCDPos] = 0;
		LCDUpdate();
	#endif
}

// Processes A/D data from the potentiometer
static void ProcessIO(void)
{
#if defined(__C30__) || defined(__C32__)
    // Convert potentiometer result into ASCII string
    uitoa((WORD)ADC1BUF0, AN0String);
#else
    // AN0 should already be set up as an analog input
    ADCON0bits.GO = 1;

    // Wait until A/D conversion is done
    while(ADCON0bits.GO);

	// AD converter errata work around (ex: PIC18F87J10 A2)
	#if !defined(__18F87J50) && !defined(_18F87J50)
		PRODL = ADCON2;
		ADCON2bits.ADCS0 = 1;
		ADCON2bits.ADCS1 = 1;
		ADCON2 = PRODL;
	#endif

    // Convert 10-bit value into ASCII string
    uitoa(*((WORD*)(&ADRESL)), AN0String);
#endif
}

/*********************************************************************
 * Function:        void InitializeBoard(void)
 *
 * PreCondition:    None
 *
 * Input:           None
 *
 * Output:          None
 *
 * Side Effects:    None
 *
 * Overview:        Initialize board specific hardware.
 *
 * Note:            None
 ********************************************************************/
static void InitializeBoard(void)
{ 
BYTE PortData;
// Initially 'RESET' all MCP23017 IO Extenders 
 
MCP23017_Reset_io = 1;		//preconfigure the uP IO output being used as a high
MCP23017_Reset_tris = 0;	//configure the uP IO being used as an output
MCP23017_Reset_io = 0;		//pulse the line low then high to reset all MCP23017's,
i2c_wait(1);				//2us wait
MCP23017_Reset_io = 1;		//spec is RESET must be 1us minimum low

EmailAlertBusyFlag = FALSE;			//clear EmailAlertBusyFla, indicate it is not processing an alert email
EmailDLogBusyFlag = FALSE;			//clear EmailDLogBusyFlag, indicate it is not processing a data log email

InitializeBeeTrafficCounters(BeeTrafficPort);		//Initial the bee traffic counter MCP23017, turns on the I2C port
//Turn on BTCSW for Bee Traffic Cunters, it is turned off for diagnostic/self test use
ClearRegisterBit(AuxioPort, AuxioSA, IODIRB, BTCSW_tris);	//set tris register as output
SetRegisterBit(AuxioPort, AuxioSA, GPIOB, BTCSW_io);	//now set the bit on for normal bee traffic counting

// Read AUX4 pin to determine if we are to set the TestModeBMS flag
//SetRegisterBit(unsigned char I2Cport, unsigned char SlaveAddr, unsigned char Reg, unsigned char Data);
SetRegisterBit(2, 0x48, 0x10, AuxDev4_tris);  	//set IODIRB for AuxDev4 tris bit for input mode
SetRegisterBit(2, 0x48, 0x16, AuxDev4_tris);	//set GPPUB for internal pull-up resistor	 
i2c_wait(1); 			//give it some time to execute


//MCP23017_readRegister(unsigned char I2Cport, unsigned char SlaveAddr, unsigned char Reg);
PortData = MCP23017_readRegister(2, 0x48, 0x19);
if ((PortData & AuxDev4_io) == AuxDev4_io)
	TestModeBMS = FALSE;
	else
		TestModeBMS = TRUE;

// set a couple of defaults for the graphs
BarGraph1DayL = 1;	//Dispaly graph on left bar
BarGraph1DayR = 0;	//Dispaly graph on right bar
BarGraph2DayL = 1;	//Dispaly graph on left bar
BarGraph2DayR = 0;	//Dispaly graph on right bar

//set up the MCP23017 for servo power on/off control
	MCP23017_writeRegister(AuxioPort, AuxioSA, 0x09, 0x00);	//set GPIOA register all low						
	MCP23017_writeRegister(AuxioPort, AuxioSA, 0x00, 0x00);	//set IODIRA register all low for servo Pwr off
	MCP23017_writeRegister(AuxioPort, AuxioSA, 0x10, 0x00);	//set IODIRB register all outputs

	ServoBusyFlag = FALSE;		//start with no servos busy

// BMS LED IO. set IO's for output drive
	GreenStatusLEDio = 0;
	GreenStatusLEDtris = 0;
	YellowStatusLEDio= 0;
	YellowStatusLEDtris= 0;
	RedStatusLEDio = 0;
	RedStatusLEDtris = 0;
	Tamper_Alarm_LEDio = 0;
	Tamper_Alarm_LEDtris = 0;
	Hive_Movement_Alarm_LEDio = 0;
	Hive_Movement_Alarm_LEDtris = 0;
	PIR_Motion_Alarm_LEDio = 0;
	PIR_Motion_Alarm_LEDtris = 0;
	Bee_Leaving_Hive_LEDio = 0;
	Bee_Leaving_Hive_LEDtris = 0;
	Bee_Entering_Hive_LEDio = 0;
	Bee_Entering_Hive_LEDtris = 0;
	Smoke_Module_LEDtris = 0;
	Smoke_Module_LEDio = 0;
	Fence_Module_LEDtris = 0;
	Fence_Module_LEDio = 0;


//RTCC
RtccOpen(tm.l, dt.l, 0);				//setup the RTCC to run
while(RtccGetClkStat()!=RTCC_CLK_ON);	// wait for the SOSC to be actually running and RTCC to have
										// its clock source. Could wait here at most 32ms
//load clock with default date/time
tm.l=0;
tm.sec=tmsec;				//0-59
tm.min=tmmin;				//0-59
tm.hour=tmhour;				//0-23
dt.wday=dtwday;				//0-6,	Sun = 0
dt.mday=dtmday;				//1-31
dt.mon=dtmon;				//0-11, Jan = 0
dt.year=dtyear;				//0-99,	Starting at year 2000
RtccSetTimeDate(tm.l, dt.l);	//set the RTCC
RtccSetCalibration(0);		//clock currently runs slow about 1 second per minute
//===

#include "InitDataLogInterval.c"

// initialize start/stop time defaults for graph functions
AnalysisTime[AnalysisStartTimeTopL] = 0;			//Analysis start time for top graph
AnalysisTime[AnalysisStopTimeTopL] = 23;			//Analysis stop time for top graph
AnalysisTime[AnalysisStartTimeTopR] = 0;			//Analysis start time for top graph
AnalysisTime[AnalysisStopTimeTopR] = 23;			//Analysis stop time for top graph
AnalysisTime[AnalysisStartTimeBottomL] = 0;		//Analysis start time for bottom graph
AnalysisTime[AnalysisStopTimeBottomL] = 23;		//Analysis stop time for bottom graph
AnalysisTime[AnalysisStartTimeBottomR] = 0;		//Analysis start time for bottom graph
AnalysisTime[AnalysisStopTimeBottomR] = 23;		//Analysis stop time for bottom graph

//Sound PWM
//Vibration PWM
//Entrance PWM					/used as PWM currently

//Heater PWM
	HeatingModule_LEDio = 0;		//on/off mode used currently, can be chaned to PWM output if required
	HeatingModule_LEDtris = 0;
//Cooling PWM
	CoolingModule_LEDio = 0;		//on/off mode used currently, can be chaned to PWM output if required
	CoolingModule_LEDtris = 0;

	ExteriorLight_Module_LEDio = 0;
	ExteriorLight_Module_LEDtris = 0;
	InteriorLight_Module_LEDio = 0;
	InteriorLight_Module_LEDtris = 0;
	

// BMS sensor inputs
	SW_LidOpen_Tris	 = 1;			//Lid Open hall sensor
	SW_TiltDetect_Tris = 1;			//Tilt detect hall sensor
// set PIR as input pins
	SW_PIR_1_TRIS = 1;
	SW_PIR_2_TRIS = 1;
	SW_PIR_3_TRIS = 1;
	SW_PIR_4_TRIS = 1;

InitializeBarGraphArray();		//simulation data for program development

#if defined(__18CXX)
	// Enable 4x/5x PLL on PIC18F87J10, PIC18F97J60, etc.
    OSCTUNE = 0x40;

	// Set up analog features of PORTA

	// PICDEM.net 2 board has POT on AN2, Temp Sensor on AN3
	#if defined(PICDEMNET2)
		ADCON0 = 0x09;		// ADON, Channel 2
		ADCON1 = 0x0B;		// Vdd/Vss is +/-REF, AN0, AN1, AN2, AN3 are analog
	#elif defined(PICDEMZ)
		ADCON0 = 0x81;		// ADON, Channel 0, Fosc/32
		ADCON1 = 0x0F;		// Vdd/Vss is +/-REF, AN0, AN1, AN2, AN3 are all digital
	#else
		ADCON0 = 0x01;		// ADON, Channel 0
		ADCON1 = 0x0E;		// Vdd/Vss is +/-REF, AN0 is analog
	#endif
	#if defined(__18F87J50) || defined(_18F87J50)
		#define ADCON2		ADCON1
	#endif
	ADCON2 = 0xBE;			// Right justify, 20TAD ACQ time, Fosc/64 (~21.0kHz)


    // Enable internal PORTB pull-ups
    INTCON2bits.RBPU = 0;

	// Configure USART
    TXSTA = 0x20;
    RCSTA = 0x90;

	// See if we can use the high baud rate setting
	#if ((GetPeripheralClock()+2*BAUD_RATE)/BAUD_RATE/4 - 1) <= 255
		SPBRG = (GetPeripheralClock()+2*BAUD_RATE)/BAUD_RATE/4 - 1;
		TXSTAbits.BRGH = 1;
	#else	// Use the low baud rate setting
		SPBRG = (GetPeripheralClock()+8*BAUD_RATE)/BAUD_RATE/16 - 1;
	#endif


	// Enable Interrupts
	RCONbits.IPEN = 1;		// Enable interrupt priorities
    INTCONbits.GIEH = 1;
    INTCONbits.GIEL = 1;

    // Do a calibration A/D conversion
	#if defined(__18F87J10) || defined(__18F86J15) || defined(__18F86J10) || defined(__18F85J15) || defined(__18F85J10) || defined(__18F67J10) || defined(__18F66J15) || defined(__18F66J10) || defined(__18F65J15) || defined(__18F65J10) || defined(__18F97J60) || defined(__18F96J65) || defined(__18F96J60) || defined(__18F87J60) || defined(__18F86J65) || defined(__18F86J60) || defined(__18F67J60) || defined(__18F66J65) || defined(__18F66J60) || \
	defined(_18F87J10)  || defined(_18F86J15)  || defined(_18F86J10)  || defined(_18F85J15)  || defined(_18F85J10)  || defined(_18F67J10)  || defined(_18F66J15)  || defined(_18F66J10)  || defined(_18F65J15)  || defined(_18F65J10)  || defined(_18F97J60)  || defined(_18F96J65)  || defined(_18F96J60)  || defined(_18F87J60)  || defined(_18F86J65)  || defined(_18F86J60)  || defined(_18F67J60)  || defined(_18F66J65)  || defined(_18F66J60)
		ADCON0bits.ADCAL = 1;
	    ADCON0bits.GO = 1;
		while(ADCON0bits.GO);
		ADCON0bits.ADCAL = 0;
	#endif

#else	// 16-bit C30 and and 32-bit C32
	#if defined(__PIC32MX__)
	{
		// Enable multi-vectored interrupts
		INTEnableSystemMultiVectoredInt();
		
		// Enable optimal performance
		SYSTEMConfigPerformance(GetSystemClock());
		mOSCSetPBDIV(OSC_PB_DIV_1);				// Use 1:1 CPU Core:Peripheral clocks
		
		// Disable JTAG port so we get our I/O pins back, but first
		// wait 50ms so if you want to reprogram the part with 
		// JTAG, you'll still have a tiny window before JTAG goes away
		DelayMs(50);
	//	DDPCONbits.JTAGEN = 0;
	//	LED_PUT(0x00);				// Turn the LEDs off
	}
	#endif

	#if defined(__dsPIC33F__) || defined(__PIC24H__)
		// Crank up the core frequency
		PLLFBD = 38;				// Multiply by 40 for 160MHz VCO output (8MHz XT oscillator)
		CLKDIV = 0x0000;			// FRC: divide by 2, PLLPOST: divide by 2, PLLPRE: divide by 2
	
		// Port I/O
		AD1PCFGHbits.PCFG23 = 1;	// Make RA7 (BUTTON1) a digital input

		// ADC
	    AD1CHS0 = 0;				// Input to AN0 (potentiometer)
		AD1PCFGLbits.PCFG5 = 0;		// Disable digital input on AN5 (potentiometer)
		AD1PCFGLbits.PCFG4 = 0;		// Disable digital input on AN4 (TC1047A temp sensor)
	#else	//defined(__PIC24F__) || defined(__PIC32MX__)
		// ADC
	    AD1CHS = 0;					// Input to AN0 (potentiometer)
		AD1PCFGbits.PCFG4 = 0;		// Disable digital input on AN4 (TC1047A temp sensor)
		#if defined(__32MX460F512L__)	// PIC32MX460F512L PIM has different pinout to accomodate USB module
			AD1PCFGbits.PCFG2 = 0;		// Disable digital input on AN2 (potentiometer)
		#else
			AD1PCFGbits.PCFG5 = 0;		// Disable digital input on AN5 (potentiometer)
		#endif
	#endif

	// ADC
	AD1CON1 = 0x84E4;			// Turn on, auto sample start, auto-convert, 12 bit mode (on parts with a 12bit A/D)
	AD1CON2 = 0x0404;			// AVdd, AVss, int every 2 conversions, MUXA only, scan
	AD1CON3 = 0x1003;			// 16 Tad auto-sample, Tad = 3*Tcy
	#if defined(__32MX460F512L__)	// PIC32MX460F512L PIM has different pinout to accomodate USB module
		AD1CSSL = 1<<2;				// Scan pot
	#else
		AD1CSSL = 1<<5;				// Scan pot
	#endif

#include "BMS_ADC_scan_setup.c"		//initialize the ADC for scanning


	// UART
	#if defined(STACK_USE_UART)
		UARTTX_TRIS = 0;
		UARTRX_TRIS = 1;
		UMODE = 0x8000;			// Set UARTEN.  Note: this must be done before setting UTXEN

		#if defined(__C30__)
			USTA = 0x0400;		// UTXEN set
			#define CLOSEST_UBRG_VALUE ((GetPeripheralClock()+8ul*BAUD_RATE)/16/BAUD_RATE-1)
			#define BAUD_ACTUAL (GetPeripheralClock()/16/(CLOSEST_UBRG_VALUE+1))
		#else	//defined(__C32__)
			USTA = 0x00001400;		// RXEN set, TXEN set
			#define CLOSEST_UBRG_VALUE ((GetPeripheralClock()+8ul*BAUD_RATE)/16/BAUD_RATE-1)
			#define BAUD_ACTUAL (GetPeripheralClock()/16/(CLOSEST_UBRG_VALUE+1))
		#endif
	
		#define BAUD_ERROR ((BAUD_ACTUAL > BAUD_RATE) ? BAUD_ACTUAL-BAUD_RATE : BAUD_RATE-BAUD_ACTUAL)
		#define BAUD_ERROR_PRECENT	((BAUD_ERROR*100+BAUD_RATE/2)/BAUD_RATE)
		#if (BAUD_ERROR_PRECENT > 3)
			#warning UART frequency error is worse than 3%
		#elif (BAUD_ERROR_PRECENT > 2)
			#warning UART frequency error is worse than 2%
		#endif
	
		UBRG = CLOSEST_UBRG_VALUE;
	#endif

#endif

#if defined(PIC24FJ64GA004_PIM)
	// Remove some LED outputs to regain other functions
	LED1_TRIS = 1;		// Multiplexed with BUTTON0
	LED5_TRIS = 1;		// Multiplexed with EEPROM CS
	LED7_TRIS = 1;		// Multiplexed with BUTTON1
	
	// Inputs
	RPINR19bits.U2RXR = 19;			//U2RX = RP19
	RPINR22bits.SDI2R = 20;			//SDI2 = RP20
	RPINR20bits.SDI1R = 17;			//SDI1 = RP17
	
	// Outputs
	RPOR12bits.RP25R = U2TX_IO;		//RP25 = U2TX  
	RPOR12bits.RP24R = SCK2OUT_IO; 	//RP24 = SCK2
	RPOR10bits.RP21R = SDO2_IO;		//RP21 = SDO2
	RPOR7bits.RP15R = SCK1OUT_IO; 	//RP15 = SCK1
	RPOR8bits.RP16R = SDO1_IO;		//RP16 = SDO1
	
	AD1PCFG = 0xFFFF;				//All digital inputs - POT and Temp are on same pin as SDO1/SDI1, which is needed for ENC28J60 commnications

	// Lock the PPS
	asm volatile (	"mov #OSCCON,w1 \n"
					"mov #0x46, w2 \n"
					"mov #0x57, w3 \n"
					"mov.b w2,[w1] \n"
					"mov.b w3,[w1] \n"
					"bset OSCCON, #6");
#endif

#if defined(DSPICDEM11)
	// Deselect the LCD controller (PIC18F252 onboard) to ensure there is no SPI2 contention
	LCDCTRL_CS_TRIS = 0;
	LCDCTRL_CS_IO = 1;

	// Hold the codec in reset to ensure there is no SPI2 contention
	CODEC_RST_TRIS = 0;
	CODEC_RST_IO = 0;
#endif

#if defined(SPIRAM_CS_TRIS)
	SPIRAMInit();
#endif
}

/*********************************************************************
 * Function:        void InitAppConfig(void)
 *
 * PreCondition:    MPFSInit() is already called.
 *
 * Input:           None
 *
 * Output:          Write/Read non-volatile config variables.
 *
 * Side Effects:    None
 *
 * Overview:        None
 *
 * Note:            None
 ********************************************************************/
// Uncomment these two pragmas for production MAC address 
// serialization if using C18. The MACROM=0x1FFF0 statement causes 
// the MAC address to be located at aboslute program memory address 
// 0x1FFF0 for easy auto-increment without recompiling the stack for 
// each device made.  Note, other compilers/linkers use a different 
// means of allocating variables at an absolute address.  Check your 
// compiler documentation for the right method.
//#pragma romdata MACROM=0x1FFF0
static ROM BYTE SerializedMACAddress[6] = {MY_DEFAULT_MAC_BYTE1, MY_DEFAULT_MAC_BYTE2, MY_DEFAULT_MAC_BYTE3, MY_DEFAULT_MAC_BYTE4, MY_DEFAULT_MAC_BYTE5, MY_DEFAULT_MAC_BYTE6};
//#pragma romdata

static void InitAppConfig(void)
{
#if (defined(MPFS_USE_EEPROM) || defined(MPFS_USE_SPI_FLASH)) && (defined(STACK_USE_MPFS) || defined(STACK_USE_MPFS2))
    BYTE c;
    BYTE *p;
#endif

	AppConfig.Flags.bIsDHCPEnabled = TRUE;
	AppConfig.Flags.bInConfigMode = TRUE;
	memcpypgm2ram((void*)&AppConfig.MyMACAddr, (ROM void*)SerializedMACAddress, sizeof(AppConfig.MyMACAddr));
//	{
//		_prog_addressT MACAddressAddress;
//		MACAddressAddress.next = 0x157F8;
//		_memcpy_p2d24((char*)&AppConfig.MyMACAddr, MACAddressAddress, sizeof(AppConfig.MyMACAddr));
//	}
	AppConfig.MyIPAddr.Val = MY_DEFAULT_IP_ADDR_BYTE1 | MY_DEFAULT_IP_ADDR_BYTE2<<8ul | MY_DEFAULT_IP_ADDR_BYTE3<<16ul | MY_DEFAULT_IP_ADDR_BYTE4<<24ul;
	AppConfig.DefaultIPAddr.Val = AppConfig.MyIPAddr.Val;
	AppConfig.MyMask.Val = MY_DEFAULT_MASK_BYTE1 | MY_DEFAULT_MASK_BYTE2<<8ul | MY_DEFAULT_MASK_BYTE3<<16ul | MY_DEFAULT_MASK_BYTE4<<24ul;
	AppConfig.DefaultMask.Val = AppConfig.MyMask.Val;
	AppConfig.MyGateway.Val = MY_DEFAULT_GATE_BYTE1 | MY_DEFAULT_GATE_BYTE2<<8ul | MY_DEFAULT_GATE_BYTE3<<16ul | MY_DEFAULT_GATE_BYTE4<<24ul;
	AppConfig.PrimaryDNSServer.Val = MY_DEFAULT_PRIMARY_DNS_BYTE1 | MY_DEFAULT_PRIMARY_DNS_BYTE2<<8ul  | MY_DEFAULT_PRIMARY_DNS_BYTE3<<16ul  | MY_DEFAULT_PRIMARY_DNS_BYTE4<<24ul;
	AppConfig.SecondaryDNSServer.Val = MY_DEFAULT_SECONDARY_DNS_BYTE1 | MY_DEFAULT_SECONDARY_DNS_BYTE2<<8ul  | MY_DEFAULT_SECONDARY_DNS_BYTE3<<16ul  | MY_DEFAULT_SECONDARY_DNS_BYTE4<<24ul;

	// Load the default NetBIOS Host Name
	memcpypgm2ram(AppConfig.NetBIOSName, (ROM void*)MY_DEFAULT_HOST_NAME, 16);
	FormatNetBIOSName(AppConfig.NetBIOSName);

#if defined(MPFS_USE_EEPROM) && (defined(STACK_USE_MPFS) || defined(STACK_USE_MPFS2))
    p = (BYTE*)&AppConfig;

    XEEBeginRead(0x0000);
    c = XEERead();
    XEEEndRead();

    // When a record is saved, first byte is written as 0x60 to indicate
    // that a valid record was saved.  Note that older stack versions 
	// used 0x57.  This change has been made to so old EEPROM contents 
	// will get overwritten.  The AppConfig() structure has been changed,
	// resulting in parameter misalignment if still using old EEPROM 
	// contents.
    if(c == 0x60u)
    {
        XEEBeginRead(0x0001);
        for ( c = 0; c < sizeof(AppConfig); c++ )
            *p++ = XEERead();
        XEEEndRead();
    }
    else
        SaveAppConfig();

#elif defined(MPFS_USE_SPI_FLASH) && (defined(STACK_USE_MPFS) || defined(STACK_USE_MPFS2))
	SPIFlashReadArray(0x00, &c, 1);
	if(c == 0x60u)
		SPIFlashReadArray(0x01, (BYTE*)&AppConfig, sizeof(AppConfig));
	else
		SaveAppConfig();
#endif
}

#if (defined(MPFS_USE_EEPROM) || defined(MPFS_USE_SPI_FLASH)) && (defined(STACK_USE_MPFS) || defined(STACK_USE_MPFS2))
void SaveAppConfig(void)
{
	#if defined(MPFS_USE_EEPROM)

    BYTE c;
    BYTE *p;

    p = (BYTE*)&AppConfig;
    XEEBeginWrite(0x0000);
    XEEWrite(0x60);
    for ( c = 0; c < sizeof(AppConfig); c++ )
    {
        XEEWrite(*p++);
    }

    XEEEndWrite();
    
    #else

    SPIFlashBeginWrite(0x0000);
    SPIFlashWrite(0x60);
    SPIFlashWriteArray((BYTE*)&AppConfig, sizeof(AppConfig));
    
    #endif
}




#endif

